
// DRY LANDS TWC
// OKTOBER 2006 BY MARTIN 'ORCA' SCHMIDT

void main(void)
{
   // MAPSIZE 
   int playerTiles=10000;
   if (cNumberNonGaiaPlayers == 2)
     playerTiles = 13000;
   if (cNumberNonGaiaPlayers == 4)
     playerTiles = 10000;
   if (cNumberNonGaiaPlayers == 6)
     playerTiles = 9000;
   if (cNumberNonGaiaPlayers == 8)
     playerTiles = 8000;
 
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1);
	
   // TERRAIN 
   rmSetSeaLevel(0.0);
   rmSetLightingSet("Texas");
   rmSetSeaType("Amazon River");
   rmTerrainInitialize("texas\ground1_tex", 0.0);

   // THIS LINES MUST BE HERE FOR TREASURES
   rmSetMapType("texas");
   // rmSetMapType("grass");
   rmSetMapType("land");

   // CLASSES
   int classPlayer=rmDefineClass("player");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("natives");
   rmDefineClass("classNuggets");
   rmDefineClass("center");
   rmDefineClass("classSocket");
   rmDefineClass("huntables");

   rmSetSubCiv(0, "Cheyenne");
   rmSetSubCiv(1, "Cherokee");

   // COMMON CONSTRAINTS 
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAllFar=rmCreateTypeDistanceConstraint("avoid all Far", "all", 10.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidTCFar=rmCreateTypeDistanceConstraint("objects avoid TC Far", "towncenter", 90.0);
   int avoidTC=rmCreateTypeDistanceConstraint("objects avoid TC ", "towncenter", 75.0);
   int avoidTCSmall=rmCreateTypeDistanceConstraint("objects avoid TC small", "towncenter", 50.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 50.0);
   int huntAvoidHunt=rmCreateClassDistanceConstraint("Hunt vs Hunt", rmClassID("huntables"), 50.0);
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int avoidNuggets=rmCreateClassDistanceConstraint("nuggets avoids nuggets", rmClassID("classNuggets"), 75.0 - cNumberNonGaiaPlayers * 2.5);
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 30.0);

   // Cardinal Directions
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // OVERLAY
   int OverlayID=rmCreateArea("OVERLAY");
   rmSetAreaSize(OverlayID, 0.8, 0.8);	
   rmSetAreaCoherence(OverlayID, 1.0);	
   rmSetAreaSmoothDistance(OverlayID, 10);
   rmSetAreaMix(OverlayID, "texas_dirt");
   rmSetAreaBaseHeight(OverlayID, 0.0);   
   rmSetAreaLocation(OverlayID, 0.5, 0.5);
   rmBuildArea(OverlayID);

   // MIDDLE
   int MiddleID=rmCreateArea("middle");
   rmSetAreaSize(MiddleID, 0.1, 0.1);	
   rmSetAreaCoherence(MiddleID, 0.8);	
   rmSetAreaSmoothDistance(MiddleID, 10);
   rmSetAreaMix(MiddleID, "texas_dirt");
   rmSetAreaBaseHeight(MiddleID, 0.0);   
   rmSetAreaLocation(MiddleID, 0.5, 0.5);
   rmBuildArea(MiddleID);

   int stayOutsideMiddle = rmCreateAreaDistanceConstraint("stayOutsideMiddle", MiddleID, 30.0);
   int stayOutsideMiddleFar = rmCreateAreaDistanceConstraint("stayOutsideMiddleFar", MiddleID, 50.0);

   // WATER 
   int PondAID=rmCreateArea("Pond A",MiddleID);
   rmSetAreaSize(PondAID, 0.008, 0.008);	
   rmSetAreaCoherence(PondAID, 0.5);	
   rmSetAreaSmoothDistance(PondAID, 10);
   rmSetAreaWaterType(PondAID, "bayou");
   rmSetAreaBaseHeight(PondAID, 0.0);   
   rmBuildArea(PondAID);

   int avoidPondAID = rmCreateAreaDistanceConstraint("Keep distance pond A",PondAID,40.0);

   int PondBID=rmCreateArea("Pond B",MiddleID);
   rmAddAreaConstraint(PondBID, avoidPondAID);
   rmSetAreaSize(PondBID, 0.008, 0.008);	
   rmSetAreaCoherence(PondBID, 0.5);	
   rmSetAreaSmoothDistance(PondBID, 10);
   rmSetAreaWaterType(PondBID, "bayou");
   rmSetAreaBaseHeight(PondBID, 0.0);   
   rmBuildArea(PondBID);

   int avoidPondBID = rmCreateAreaDistanceConstraint("Keep distance pond B",PondBID,40.0);

   if(cNumberNonGaiaPlayers >= 4)
   {
     int PondCID=rmCreateArea("Pond C",MiddleID);
     rmAddAreaConstraint(PondCID, avoidPondAID);
     rmAddAreaConstraint(PondCID, avoidPondBID);
     rmSetAreaSize(PondCID, 0.008, 0.008);	
     rmSetAreaCoherence(PondCID, 0.5);	
     rmSetAreaSmoothDistance(PondCID, 10);
     rmSetAreaWaterType(PondCID, "bayou");
     rmSetAreaBaseHeight(PondCID, 0.0);   
     rmBuildArea(PondCID);

     int avoidPondCID = rmCreateAreaDistanceConstraint("Keep distance pond C",PondCID,40.0);
   }

   if(cNumberNonGaiaPlayers >= 8)
   {
     int PondDID=rmCreateArea("Pond D",MiddleID);
     rmAddAreaConstraint(PondDID, avoidPondAID);
     rmAddAreaConstraint(PondDID, avoidPondBID);
     rmAddAreaConstraint(PondDID, avoidPondCID);
     rmSetAreaSize(PondDID, 0.008, 0.008);	
     rmSetAreaCoherence(PondDID, 0.5);	
     rmSetAreaSmoothDistance(PondDID, 10);
     rmSetAreaWaterType(PondDID, "bayou");
     rmSetAreaBaseHeight(PondDID, 0.0);   
     rmBuildArea(PondDID);
   }
   
   if(cNumberNonGaiaPlayers == 2)
   {
     // PALYER PLACEMENT 
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.87,0.97);			
     rmPlacePlayersCircular(0.38, 0.4, 0);	
			
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.37,0.47);		
     rmPlacePlayersCircular(0.38, 0.4, 0);
   }

   else if(cNumberNonGaiaPlayers == 4)
   {
     // PALYER PLACEMENT 
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.88,0.12);			
     rmPlacePlayersCircular(0.38, 0.4, 0);	
			
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.38,0.62);		
     rmPlacePlayersCircular(0.38, 0.4, 0);
   }

   else if(cNumberNonGaiaPlayers == 6)
   {
     // PALYER PLACEMENT 
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.80,0.12);			
     rmPlacePlayersCircular(0.4, 0.42, 0);	
			
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.30,0.62);		
     rmPlacePlayersCircular(0.4, 0.42, 0);
   }

   else if(cNumberNonGaiaPlayers == 8)
   {
     // PALYER PLACEMENT 
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.80,0.20);			
     rmPlacePlayersCircular(0.4, 0.42, 0);	
			
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.30,0.70);		
     rmPlacePlayersCircular(0.4, 0.42, 0);
   }

   // FFA SUPPORT 
   else
   {
     rmSetPlacementTeam(-1);				
     rmSetPlacementSection(0.02,0.01);		
     rmPlacePlayersCircular(0.4, 0.42, 0);
   }

   // PLAYER AREAS
   float playerFraction=rmAreaTilesToFraction(2500);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmSetAreaCoherence(id, 1.0);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaTerrainType(id, "newengland_grass");
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();

   // PLAYER FOREST AREAS 
   int ContinentAID=rmCreateArea("continent a",rmAreaID("Player"+1));
   rmSetAreaSize(ContinentAID, 1.0, 1.0);	
   rmSetAreaMix(ContinentAID, "texas_dirt");
   rmSetAreaBaseHeight(ContinentAID, 0.0); 

   int ContinentBID=rmCreateArea("continent b",rmAreaID("Player"+2));
   rmSetAreaSize(ContinentBID, 1.0, 1.0);	
   rmSetAreaMix(ContinentBID, "texas_dirt");
   rmSetAreaBaseHeight(ContinentBID, 0.0);

   if(cNumberNonGaiaPlayers >= 3)
   {
     int ContinentCID=rmCreateArea("continent c",rmAreaID("Player"+3));
     rmSetAreaSize(ContinentCID, 1.0, 1.0);	
     rmSetAreaMix(ContinentCID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentCID, 0.0); 
   }

   if(cNumberNonGaiaPlayers >= 4)
   {
     int ContinentDID=rmCreateArea("continent d",rmAreaID("Player"+4));
     rmSetAreaSize(ContinentDID, 1.0, 1.0);	
     rmSetAreaMix(ContinentDID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentDID, 0.0);
   }

   if(cNumberNonGaiaPlayers >= 5)
   {
     int ContinentEID=rmCreateArea("continent e",rmAreaID("Player"+5));
     rmSetAreaSize(ContinentEID, 1.0, 1.0);	
     rmSetAreaMix(ContinentEID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentEID, 0.0); 
   }

   if(cNumberNonGaiaPlayers >= 6)
   {
     int ContinentFID=rmCreateArea("continent f",rmAreaID("Player"+6));
     rmSetAreaSize(ContinentFID, 1.0, 1.0);	
     rmSetAreaMix(ContinentFID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentFID, 0.0);
   }

   if(cNumberNonGaiaPlayers >= 7)
   {
     int ContinentGID=rmCreateArea("continent g",rmAreaID("Player"+7));
     rmSetAreaSize(ContinentGID, 1.0, 1.0);	
     rmSetAreaMix(ContinentGID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentGID, 0.0); 
   }

   if(cNumberNonGaiaPlayers >= 8)
   {
     int ContinentHID=rmCreateArea("continent h",rmAreaID("Player"+8));
     rmSetAreaSize(ContinentHID, 1.0, 1.0);	
     rmSetAreaMix(ContinentHID, "texas_dirt");
     rmSetAreaBaseHeight(ContinentHID, 0.0);
   }

   rmBuildAllAreas();

   // STARTING UNITS 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);

   // STARTING PLACE 
   int startingTCID= rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
     rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   else
     rmAddObjectDefItem(startingTCID, "townCenter", 1, 0.0);

	
   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // INDIANS 
   int IndianVillageAID = -1;
   int IndianVillageTypeA = rmRandInt(1,3);
   IndianVillageAID = rmCreateGrouping("lakota city a", "native Cheyenne village "+IndianVillageTypeA);
   rmAddGroupingToClass(IndianVillageAID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(IndianVillageAID, 0, 0.25, 0.61);
   rmPlaceGroupingAtLoc(IndianVillageAID, 0, 0.75, 0.39);
   if(cNumberNonGaiaPlayers >= 4)
   {
     rmPlaceGroupingAtLoc(IndianVillageAID, 0, 0.25, 0.39);
     rmPlaceGroupingAtLoc(IndianVillageAID, 0, 0.75, 0.61);
   }

   int IndianVillageBID = -1;
   int IndianVillageTypeB = rmRandInt(1,3);
   IndianVillageBID = rmCreateGrouping("cherokee city b", "native cherokee village "+IndianVillageTypeB);
   rmAddGroupingToClass(IndianVillageBID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(IndianVillageBID, 0, 0.39, 0.75);
   rmPlaceGroupingAtLoc(IndianVillageBID, 0, 0.61, 0.25);
   if(cNumberNonGaiaPlayers >= 4)
   {
     rmPlaceGroupingAtLoc(IndianVillageBID, 0, 0.62, 0.75);
     rmPlaceGroupingAtLoc(IndianVillageBID, 0, 0.38, 0.25);
   }

   if(cNumberNonGaiaPlayers >= 2)
   {
     int rivermin = 3;
     int rivermax = 4;

     int RiverA = rmRiverCreate(-1, "Amazon River", 1, 10, rivermin, rivermax); // SINGLE WIDE RIVER
     rmRiverSetConnections(RiverA, 0.5, 0.0, 0.5, 0.25);
     rmRiverSetBankNoiseParams(RiverA, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
     rmRiverBuild(RiverA);

     int RiverB = rmRiverCreate(-1, "Amazon River", 1, 10, rivermin, rivermax); // SINGLE WIDE RIVER
     rmRiverSetConnections(RiverB, 0.5, 1.0, 0.5, 0.75);
     rmRiverSetBankNoiseParams(RiverB, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
     rmRiverBuild(RiverB);
   }

   if(cNumberNonGaiaPlayers >= 4)
   {
     int RiverC = rmRiverCreate(-1, "Amazon River", 1, 10, rivermin, rivermax); // SINGLE WIDE RIVER
     rmRiverSetConnections(RiverC, 0.0, 0.5, 0.25, 0.5);
     rmRiverSetBankNoiseParams(RiverC, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
     rmRiverBuild(RiverC);

     int RiverD = rmRiverCreate(-1, "Amazon River", 1, 10, rivermin, rivermax); // SINGLE WIDE RIVER
     rmRiverSetConnections(RiverD, 1.0, 0.5, 0.75, 0.5);
     rmRiverSetBankNoiseParams(RiverD, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
     rmRiverBuild(RiverD);
   }

   // FOREST 
   int numForest = -1;
   int failCount = -1;
   numForest=5 + cNumberNonGaiaPlayers/2;  
   failCount=0;

   for (i=0; <numForest)
   {   
      int Forest=rmCreateArea("Forest"+i);
      rmSetAreaSize(Forest, rmAreaTilesToFraction(70), rmAreaTilesToFraction(90));
      rmSetAreaForestType(Forest, "texas forest dirt");
      rmSetAreaForestDensity(Forest, 0.7);
      rmSetAreaForestClumpiness(Forest, 1.0);
      rmSetAreaForestUnderbrush(Forest, 0.0);
      rmSetAreaMinBlobs(Forest, 1);
      rmSetAreaMaxBlobs(Forest, 2);
      rmSetAreaMinBlobDistance(Forest, 3.0);
      rmSetAreaMaxBlobDistance(Forest, 6.0);
      rmSetAreaCoherence(Forest, 0.7);
      rmSetAreaSmoothDistance(Forest, 0);		   
      rmAddAreaConstraint(Forest, playerConstraintForest);											
      rmAddAreaConstraint(Forest, avoidTradeRoute);
      rmAddAreaConstraint(Forest, avoidNatives);
      rmAddAreaConstraint(Forest, stayOutsideMiddle);
      rmAddAreaConstraint(Forest, Westward);
      if(rmBuildArea(Forest)==false)
      {  
         failCount++;
	 if(failCount==5)
	    break;
      }
      else
         failCount=0; 
   }

   // FOREST FOR EAST HALF
   int numForestEast = -1;
   int failCountEast = -1;
   numForestEast=5 + cNumberNonGaiaPlayers;  
   failCountEast=0;

   for (i=0; <numForestEast)
   {   
      int ForestEast=rmCreateArea("Forest"+100+i);
      rmSetAreaSize(ForestEast, rmAreaTilesToFraction(70), rmAreaTilesToFraction(90));
      rmSetAreaForestType(ForestEast, "texas forest dirt");
      rmSetAreaForestDensity(ForestEast, 0.7);
      rmSetAreaForestClumpiness(ForestEast, 1.0);
      rmSetAreaForestUnderbrush(ForestEast, 0.0);
      rmSetAreaMinBlobs(ForestEast, 1);
      rmSetAreaMaxBlobs(ForestEast, 2);
      rmSetAreaMinBlobDistance(ForestEast, 3.0);
      rmSetAreaMaxBlobDistance(ForestEast, 6.0);
      rmSetAreaCoherence(ForestEast, 0.7);
      rmSetAreaSmoothDistance(ForestEast, 0);		   
      rmAddAreaConstraint(ForestEast, playerConstraintForest);											
      rmAddAreaConstraint(ForestEast, avoidTradeRoute);
      rmAddAreaConstraint(ForestEast, avoidNatives);
      rmAddAreaConstraint(ForestEast, stayOutsideMiddle);
      rmAddAreaConstraint(ForestEast, Eastward);
      if(rmBuildArea(ForestEast)==false)
      {  
         failCountEast++;
	 if(failCountEast==5)
	    break;
      }
      else
         failCountEast=0; 
   }

   // FOREST FOR MIDDLE
   int numForestMiddle = -1;
   int failCountMiddle = -1;
   numForestMiddle=4 + cNumberNonGaiaPlayers;  
   failCountMiddle=0;

   for (i=0; <numForestMiddle)
   {   
      int ForestMiddle=rmCreateArea("Forest"+200+i,MiddleID);
      rmSetAreaSize(ForestMiddle, rmAreaTilesToFraction(120), rmAreaTilesToFraction(150));
      rmSetAreaForestType(ForestMiddle, "texas forest dirt");
      rmSetAreaForestDensity(ForestMiddle, 0.8);
      rmSetAreaForestClumpiness(ForestMiddle, 1.0);
      rmSetAreaForestUnderbrush(ForestMiddle, 0.0);
      rmSetAreaMinBlobs(ForestMiddle, 1);
      rmSetAreaMaxBlobs(ForestMiddle, 2);
      rmSetAreaMinBlobDistance(ForestMiddle, 3.0);
      rmSetAreaMaxBlobDistance(ForestMiddle, 6.0);
      rmSetAreaCoherence(ForestMiddle, 0.8);
      rmSetAreaSmoothDistance(ForestMiddle, 0);		   											
      rmAddAreaConstraint(ForestMiddle, avoidTradeRoute);
      rmAddAreaConstraint(ForestMiddle, avoidNatives);
      if(rmBuildArea(ForestMiddle)==false)
      {  
         failCountMiddle++;
	 if(failCountMiddle==5)
	    break;
      }
      else
         failCountMiddle=0; 
   }

   // PLAYER FOREST 
   int failCountPlayer = -1;
   int ForestPlayer = -1;

   for (i=1; <cNumberPlayers)
   {   
      ForestPlayer=rmCreateArea("Forest"+i+300,rmAreaID("Player"+i));
      rmSetAreaSize(ForestPlayer, rmAreaTilesToFraction(70), rmAreaTilesToFraction(90));
      rmSetAreaForestType(ForestPlayer, "texas forest dirt");

      rmSetAreaForestDensity(ForestPlayer, 1.0);
      rmSetAreaForestClumpiness(ForestPlayer, 0.0);
      rmSetAreaCoherence(ForestPlayer, 1.0);
      rmSetAreaSmoothDistance(ForestPlayer, 0);
      rmSetAreaForestUnderbrush(ForestPlayer, 0.0);
      rmSetAreaMinBlobs(ForestPlayer, 1);
      rmSetAreaMaxBlobs(ForestPlayer, 1);
      rmSetAreaMinBlobDistance(ForestPlayer, 5.0);
      rmSetAreaMaxBlobDistance(ForestPlayer, 5.0);	
      rmAddAreaConstraint(ForestPlayer, avoidAllFar);
      rmAddAreaConstraint(ForestPlayer, circleConstraint);	   

      if(rmBuildArea(ForestPlayer)==false)
      {  
         failCountPlayer++;
	 if(failCountPlayer==5)
	    break;
      }
      else
         failCountPlayer=0; 
   }


   // RESOURCES PER PLAYER 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false,3);

   int StartHuntID=rmCreateObjectDef("starting hunt");
   rmAddObjectDefItem(StartHuntID, "pronghorn", 6, 8.0);
   rmSetObjectDefMinDistance(StartHuntID, 20);
   rmSetObjectDefMaxDistance(StartHuntID, 25);
   rmAddObjectDefConstraint(StartHuntID, avoidStartResource);
   rmAddObjectDefConstraint(StartHuntID, avoidAll);
   rmAddObjectDefConstraint(StartHuntID, circleConstraint);
   rmAddObjectDefConstraint(StartHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartHuntID, avoidNatives);
   rmSetObjectDefCreateHerd(StartHuntID, true);
   rmPlaceObjectDefPerPlayer(StartHuntID, false,1);

   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, circleConstraint);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, avoidNatives);
   rmSetObjectDefMinDistance(playerGoldID, 32.0);
   rmSetObjectDefMaxDistance(playerGoldID, 35.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false,1);

   int playerBerryID=rmCreateObjectDef("player berry");
   rmAddObjectDefItem(playerBerryID, "berryBush", 1.0, 0.0);
   rmAddObjectDefConstraint(playerBerryID, avoidAll);
   rmSetObjectDefMinDistance(playerBerryID, 9.0);
   rmSetObjectDefMaxDistance(playerBerryID, 11.0);
   rmPlaceObjectDefPerPlayer(playerBerryID, false,1);

   int GoldAvoidPondAID = rmCreateAreaDistanceConstraint("GoldAvoidPond A", PondAID, 30.0);
   int GoldAvoidPondBID = rmCreateAreaDistanceConstraint("GoldAvoidPond B", PondBID, 30.0);
   int GoldAvoidPondCID = rmCreateAreaDistanceConstraint("GoldAvoidPond C", PondCID, 30.0);
   int GoldAvoidPondDID = rmCreateAreaDistanceConstraint("GoldAvoidPond D", PondDID, 30.0);

   int playerFarGoldID=rmCreateObjectDef("player silver far");
   rmAddObjectDefItem(playerFarGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerFarGoldID, avoidAll);
   rmAddObjectDefConstraint(playerFarGoldID, circleConstraint);
   rmAddObjectDefConstraint(playerFarGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerFarGoldID, avoidNatives);
   rmAddObjectDefConstraint(playerFarGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerFarGoldID, GoldAvoidPondAID);
   rmAddObjectDefConstraint(playerFarGoldID, GoldAvoidPondBID);
   if(cNumberNonGaiaPlayers >= 4)
     rmAddObjectDefConstraint(playerFarGoldID, GoldAvoidPondCID);
   if(cNumberNonGaiaPlayers >= 8)
     rmAddObjectDefConstraint(playerFarGoldID, GoldAvoidPondDID);
   rmSetObjectDefMinDistance(playerFarGoldID, 65.0);
   rmSetObjectDefMaxDistance(playerFarGoldID, 90.0);
   rmPlaceObjectDefPerPlayer(playerFarGoldID, false,1);

   int playerHerdID=rmCreateObjectDef("player herd");
   rmAddObjectDefItem(playerHerdID, "cow", 2, 3.0);
   rmAddObjectDefConstraint(playerHerdID, avoidAll);
   rmAddObjectDefConstraint(playerHerdID, avoidNatives);
   rmSetObjectDefMinDistance(playerHerdID, 20.0);
   rmSetObjectDefMaxDistance(playerHerdID, 25.0);
   rmPlaceObjectDefPerPlayer(playerHerdID, false,1);

   int farHuntID=rmCreateObjectDef("far hunt");
   rmAddObjectDefItem(farHuntID, "pronghorn", 6, 8.0);
   rmSetObjectDefMinDistance(farHuntID, 80);
   rmSetObjectDefMaxDistance(farHuntID, 100);
   rmAddObjectDefConstraint(farHuntID, avoidStartResource);
   rmAddObjectDefConstraint(farHuntID, avoidAll);
   rmAddObjectDefConstraint(farHuntID, huntAvoidHunt);
   rmAddObjectDefConstraint(farHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(farHuntID, avoidNatives);
   rmAddObjectDefConstraint(farHuntID, circleConstraint);
   rmAddObjectDefConstraint(farHuntID, stayOutsideMiddleFar);
   rmAddObjectDefConstraint(farHuntID, avoidTC);
   if(cNumberNonGaiaPlayers == 2)
     rmAddObjectDefConstraint(farHuntID, avoidImpassableLandFar);
   else 
     rmAddObjectDefConstraint(farHuntID, avoidImpassableLand);
   rmSetObjectDefCreateHerd(farHuntID, true);
   rmPlaceObjectDefPerPlayer(farHuntID, false,1);

   // ADDITIONAL RESOURCES
   int freeGoldID=rmCreateObjectDef("free gold");
   rmAddObjectDefItem(freeGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(freeGoldID, 0.0);
   rmSetObjectDefMaxDistance(freeGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(freeGoldID, avoidTCFar);
   rmAddObjectDefConstraint(freeGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(freeGoldID, avoidNatives);
   rmAddObjectDefConstraint(freeGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(freeGoldID, avoidAll);
   rmAddObjectDefConstraint(freeGoldID, circleConstraint);
   rmAddObjectDefConstraint(freeGoldID, stayOutsideMiddle);
   rmAddObjectDefConstraint(freeGoldID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(freeGoldID, 0, 0.5, 0.5,(cNumberNonGaiaPlayers / 2) + 1);

   int centerGoldID=rmCreateObjectDef("center gold");
   rmAddObjectDefItem(centerGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(centerGoldID, 0.0);
   rmSetObjectDefMaxDistance(centerGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(centerGoldID, avoidTCFar);
   rmAddObjectDefConstraint(centerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(centerGoldID, avoidNatives);
   rmAddObjectDefConstraint(centerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(centerGoldID, avoidAll);
   rmAddObjectDefConstraint(centerGoldID, avoidImpassableLand);
   rmPlaceObjectDefInArea(centerGoldID, 0, MiddleID,2);

   // PLACE CAPYBARAS AROUND WATER
   int stayOutsideWaterAID = rmCreateAreaDistanceConstraint("stayOutsideWater A", PondAID, 1.0);
   int stayCloseToWaterAID = rmCreateAreaMaxDistanceConstraint("stayCloseToWater A", PondAID, 3.0);
   int HuntAID=rmCreateObjectDef("hunt A");
   rmAddObjectDefItem(HuntAID, "capybara", 8, 8.0);
   rmAddObjectDefToClass(HuntAID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntAID, stayOutsideWaterAID);
   rmAddObjectDefConstraint(HuntAID, stayCloseToWaterAID);
   rmAddObjectDefConstraint(HuntAID, avoidAll);
   rmSetObjectDefCreateHerd(HuntAID, true);
   rmPlaceObjectDefInArea(HuntAID, 0, MiddleID, 2);

   int stayOutsideWaterBID = rmCreateAreaDistanceConstraint("stayOutsideWater B", PondBID, 1.0);
   int stayCloseToWaterBID = rmCreateAreaMaxDistanceConstraint("stayCloseToWater B", PondBID, 3.0);
   int HuntBID=rmCreateObjectDef("hunt B");
   rmAddObjectDefItem(HuntBID, "capybara", 8, 8.0);
   rmAddObjectDefToClass(HuntBID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntBID, stayOutsideWaterBID);
   rmAddObjectDefConstraint(HuntBID, stayCloseToWaterBID);
   rmAddObjectDefConstraint(HuntBID, avoidAll);
   rmSetObjectDefCreateHerd(HuntBID, true);
   rmPlaceObjectDefInArea(HuntBID, 0, MiddleID, 2);

   if(cNumberNonGaiaPlayers >= 4)
   {
     int stayOutsideWaterCID = rmCreateAreaDistanceConstraint("stayOutsideWater C", PondCID, 1.0);
     int stayCloseToWaterCID = rmCreateAreaMaxDistanceConstraint("stayCloseToWater C", PondCID, 3.0);
     int HuntCID=rmCreateObjectDef("hunt C");
     rmAddObjectDefItem(HuntCID, "capybara", 8, 8.0);
     rmAddObjectDefToClass(HuntCID, rmClassID("huntables"));
     rmAddObjectDefConstraint(HuntCID, stayOutsideWaterCID);
     rmAddObjectDefConstraint(HuntCID, stayCloseToWaterCID);
     rmAddObjectDefConstraint(HuntCID, avoidAll);
     rmSetObjectDefCreateHerd(HuntCID, true);
     rmPlaceObjectDefInArea(HuntCID, 0, MiddleID, 2);
   }

   if(cNumberNonGaiaPlayers >= 8)
   {
     int stayOutsideWaterDID = rmCreateAreaDistanceConstraint("stayOutsideWater D", PondDID, 1.0);
     int stayCloseToWaterDID = rmCreateAreaMaxDistanceConstraint("stayCloseToWater D", PondDID, 3.0);
     int HuntDID=rmCreateObjectDef("hunt D");
     rmAddObjectDefItem(HuntDID, "capybara", 8, 8.0);
     rmAddObjectDefToClass(HuntDID, rmClassID("huntables"));
     rmAddObjectDefConstraint(HuntDID, stayOutsideWaterDID);
     rmAddObjectDefConstraint(HuntDID, stayCloseToWaterDID);
     rmAddObjectDefConstraint(HuntDID, avoidAll);
     rmSetObjectDefCreateHerd(HuntDID, true);
     rmPlaceObjectDefInArea(HuntDID, 0, MiddleID, 2);
   }

   // Treasures
   int nugget1= rmCreateObjectDef("nugget easy"); 
   rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(1, 1);
   rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget1, avoidNatives);
   rmAddObjectDefConstraint(nugget1, avoidNuggets);
   rmAddObjectDefConstraint(nugget1, avoidAll);
   rmAddObjectDefConstraint(nugget1, circleConstraint);
   rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
   rmAddObjectDefToClass(nugget1, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget1, 25.0);
   rmSetObjectDefMaxDistance(nugget1, 35.0);
   rmPlaceObjectDefPerPlayer(nugget1, false, 1);

   int nugget2= rmCreateObjectDef("nugget med"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget2, avoidNatives);
   rmAddObjectDefConstraint(nugget2, avoidTCSmall);
   rmAddObjectDefConstraint(nugget2, avoidNuggets);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmAddObjectDefConstraint(nugget2, circleConstraint);
   rmAddObjectDefConstraint(nugget2, avoidImpassableLand);
   rmAddObjectDefToClass(nugget2, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget2, 60.0);
   rmSetObjectDefMaxDistance(nugget2, 85.0);
   rmPlaceObjectDefPerPlayer(nugget2, false, 2);

   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget3, avoidNatives);
   rmAddObjectDefConstraint(nugget3, avoidTCSmall);
   rmAddObjectDefConstraint(nugget3, avoidNuggets);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmAddObjectDefConstraint(nugget3, circleConstraint);
   rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
   rmAddObjectDefToClass(nugget3, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget3, 110.0);
   rmSetObjectDefMaxDistance(nugget3, 145.0 - cNumberNonGaiaPlayers * 2.5);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   // STRAGGLERS
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, "TreeTexasDirt", 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmSetObjectDefMinDistance(StragglerTreeID, 0.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <cNumberNonGaiaPlayers*5)
     rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);
}