
// GREEN VALLEY TWC
// OKTOBER 2006 BY MARTIN 'ORCA' SCHMIDT

float quad(float x=0.0) {return (x*x);}

void main(void)
{
   // MAPSIZE 
   int playerTiles=9000;
   if (cNumberNonGaiaPlayers == 2)
     playerTiles = 12000;
   if (cNumberNonGaiaPlayers == 4)
     playerTiles = 9000;
   if (cNumberNonGaiaPlayers == 6)
     playerTiles = 8000;
   if (cNumberNonGaiaPlayers == 8)
     playerTiles = 7000;
 
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1);
	
   // TERRAIN 
   rmSetSeaLevel(4.0);
   rmSetLightingSet("carolina");
   rmSetSeaType("Amazon River");
   rmTerrainInitialize("carolina_grass", 5.0);

   // THIS LINES MUST BE HERE FOR TREASURES
   rmSetMapType("carolina");
   rmSetMapType("grass");
   rmSetMapType("land");

   // CLASSES
   int classPlayer=rmDefineClass("player");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("natives");
   rmDefineClass("classNuggets");
   rmDefineClass("center");
   rmDefineClass("classSocket");
   rmDefineClass("huntables");

   // CHOOSING THE TRIBES
   int tribes = rmRandInt(0,7); 

   if(tribes == 0)
   {
     rmSetSubCiv(0, "Apache");
     rmSetSubCiv(1, "Comanche");
   }
   if(tribes == 1)
   {
     rmSetSubCiv(0, "Comanche");
     rmSetSubCiv(1, "Apache");
   }
   if(tribes == 2)
   {
     rmSetSubCiv(0, "Tupi");
     rmSetSubCiv(1, "Cherokee");
   }
   if(tribes == 3)
   {
     rmSetSubCiv(0, "Maya");
     rmSetSubCiv(1, "Cree");
   }
   if(tribes == 4)
   {
     rmSetSubCiv(0, "Cherokee");
     rmSetSubCiv(1, "Tupi");
   }
   if(tribes == 5)
   {
     rmSetSubCiv(0, "Cree");
     rmSetSubCiv(1, "Maya");
   }
   if(tribes == 6)
   {
     rmSetSubCiv(0, "Navajo");
     rmSetSubCiv(1, "Zapotec");
   }
   if(tribes == 7)
   {
     rmSetSubCiv(0, "Zapotec");
     rmSetSubCiv(1, "Navajo");
   }

   // COMMON CONSTRAINTS 
   
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int circleIndianConstraint=rmCreatePieConstraint("circle Indian Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.42), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Cardinal Directions
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);

   // Nature avoidance
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int avoidTC=rmCreateTypeDistanceConstraint("objects avoid TC", "towncenter", 25.0);
   int avoidTCFar=rmCreateTypeDistanceConstraint("objects avoid TC Far", "towncenter", 50.0);
   int avoidTC4Plus=rmCreateTypeDistanceConstraint("indian avoid TC", "towncenter", 35.0);
   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 20.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int huntAvoidHunt=rmCreateClassDistanceConstraint("Hunt vs Hunt", rmClassID("huntables"), 30.0);
   int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   
   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidNativesSmall=rmCreateClassDistanceConstraint("avoids natives small", rmClassID("natives"), 15.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 50.0);
   int avoidNuggets=rmCreateClassDistanceConstraint("nuggets avoids nuggets", rmClassID("classNuggets"), 40.0);
   int avoidNuggetsFar=rmCreateClassDistanceConstraint("nuggets avoids nuggets Far", rmClassID("classNuggets"), 80.0);

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
   int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 20.0);

   // STARTING UNITS 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);

   // STARTING PLACE 
   int startingTCID= rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
     rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   else
     rmAddObjectDefItem(startingTCID, "townCenter", 1, 0.0);

   // PLAYER STARTING COORDINATES
   float x1 = 0.0;
   float z1 = 0.0;
   float x2 = 0.0;
   float z2 = 0.0;
   float x3 = 0.0;
   float z3 = 0.0;
   float x4 = 0.0;
   float z4 = 0.0;
   float x5 = 0.0;
   float z5 = 0.0;
   float x6 = 0.0;
   float z6 = 0.0;
   float x7 = 0.0;
   float z7 = 0.0;
   float x8 = 0.0;
   float z8 = 0.0;

   // TRADEPOSTS VARIABELS 
   float tx1 = 0.0;
   float tz1 = 0.0;
   float tx2 = 0.0;
   float tz2 = 0.0;
   float txm = 0.0;
   float tzm = 0.0;

   // DISTANCE VARIABELS 
   float dt1p1 = 0.0;
   float dt1p2 = 0.0;
   float dt1p3 = 1.0;
   float dt1p4 = 1.0;
   float dt1p5 = 1.0;
   float dt1p6 = 1.0;
   float dt1p7 = 1.0;
   float dt1p8 = 1.0;
   float dt2p1 = 0.0;
   float dt2p2 = 0.0;
   float dt2p3 = 1.0;
   float dt2p4 = 1.0;
   float dt2p5 = 1.0;
   float dt2p6 = 1.0;
   float dt2p7 = 1.0;
   float dt2p8 = 1.0;
   float dtmp1 = 0.0;
   float dtmp2 = 0.0;
   float dtmp3 = 1.0;
   float dtmp4 = 1.0;
   float dtmp5 = 1.0;
   float dtmp6 = 1.0;
   float dtmp7 = 1.0;
   float dtmp8 = 1.0;
   float dt1t2 = 0.0;

   int iterations = 0;
 

     // PLACE PLAYERS NONREGULAR ON (HALF) CIRCLE 
     float pc1 = 0.0;
     float pc2 = 0.0; 
     float pc3 = 0.0;
     float pc4 = 0.0;
  
     if(cNumberNonGaiaPlayers == 2)
     {
       pc1 = rmRandFloat(0.0,1.0);
       pc2 = pc1 + rmRandFloat(0.2,0.25);
       if(pc2 > 1.0) pc2 = pc2 - 1.0;
       pc3 = pc1 + rmRandFloat(0.3,0.7);
       if(pc3 > 1.0) pc3 = pc3 - 1.0;
       pc4 = pc3 + rmRandFloat(0.2,0.25);
       if(pc4 > 1.0) pc4 = pc4 -1.0;
     }

     if(cNumberNonGaiaPlayers == 4)
     {
       pc1 = rmRandFloat(0.0,1.0);
       pc2 = pc1 + rmRandFloat(0.15,0.2);
       if(pc2 > 1.0) pc2 = pc2 - 1.0;
       pc3 = pc1 + rmRandFloat(0.40,0.60);
       if(pc3 > 1.0) pc3 = pc3 - 1.0;
       pc4 = pc3 + rmRandFloat(0.15,0.2);
       if(pc4 > 1.0) pc4 = pc4 -1.0;
     }

     if(cNumberNonGaiaPlayers == 6)
     {
       pc1 = rmRandFloat(0.0,1.0);
       pc2 = pc1 + rmRandFloat(0.22,0.27);
       if(pc2 > 1.0) pc2 = pc2 - 1.0;
       pc3 = pc1 + rmRandFloat(0.45,0.55);
       if(pc3 > 1.0) pc3 = pc3 - 1.0;
       pc4 = pc3 + rmRandFloat(0.22,0.27);
       if(pc4 > 1.0) pc4 = pc4 -1.0;
     }

     if(cNumberNonGaiaPlayers == 8)
     {
       pc1 = rmRandFloat(0.0,1.0);
       pc2 = pc1 + rmRandFloat(0.25,0.3);
       if(pc2 > 1.0) pc2 = pc2 - 1.0;
       pc3 = pc1 + rmRandFloat(0.45,0.55);
       if(pc3 > 1.0) pc3 = pc3 - 1.0;
       pc4 = pc3 + rmRandFloat(0.25,0.3);
       if(pc4 > 1.0) pc4 = pc4 -1.0;
     }

     // FOR INDIAN SETTLEMENT PLACEMENT LATER TO AVOID TPS GET PLACED TOWARDS ONE TEAM
     int centerIndianSetup = 0;
     if((pc1 <= 0.13) || ((pc1 >= 0.38) && (pc1 <= 0.63)) || (pc1 >= 0.88))
       centerIndianSetup = 1;
     else
       centerIndianSetup = 2;

     int edgeIndianSetup = 0;
     if((pc1 <= 0.0625) || ((pc1 >= 0.1875) && (pc1 <= 0.3125)) || ((pc1 >= 0.4375) && (pc1 <= 0.5625)) || ((pc1 >= 0.6875) && (pc1 <= 0.8125)) || (pc1 >= 0.9325))
       edgeIndianSetup = 1; 
     else 
       edgeIndianSetup = 2;

     
     if((cNumberNonGaiaPlayers == 2) || (cNumberNonGaiaPlayers == 4) || (cNumberNonGaiaPlayers == 6) || (cNumberNonGaiaPlayers == 8))
     {
       rmSetPlacementTeam(0);		
       rmSetPlacementSection(pc1,pc2);			
       rmPlacePlayersCircular(0.3, 0.35, 0);	
			
       rmSetPlacementTeam(1);				
       rmSetPlacementSection(pc3,pc4);		
       rmPlacePlayersCircular(0.3, 0.35, 0);
     }

     // FFA SUPPORT 
     else
     {
       rmSetPlacementTeam(-1);				
       rmSetPlacementSection(0.0,1.0);		
       rmPlacePlayersCircular(0.3, 0.35, 0);
     }
   
   // PLAYER AREAS 
   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
      // rmSetAreaTerrainType(id, "ground_grass4_gl");
      rmSetAreaTerrainType(id, "carolina_grass");
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();
	
   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // GET PLAYER LOCATIONS 
   x1 = rmPlayerLocXFraction(1);
   z1 = rmPlayerLocZFraction(1);
   x2 = rmPlayerLocXFraction(2);
   z2 = rmPlayerLocZFraction(2);

   if(cNumberNonGaiaPlayers >= 3)
   {
     x3 = rmPlayerLocXFraction(3);
     z3 = rmPlayerLocZFraction(3);
   }

   if(cNumberNonGaiaPlayers >= 4)
   {
     x4 = rmPlayerLocXFraction(4);
     z4 = rmPlayerLocZFraction(4);
   }

   if(cNumberNonGaiaPlayers >= 5)
   {
     x5 = rmPlayerLocXFraction(5);
     z5 = rmPlayerLocZFraction(5);
   }

   if(cNumberNonGaiaPlayers >= 6)
   {
     x6 = rmPlayerLocXFraction(6);
     z6 = rmPlayerLocZFraction(6);
   }

   if(cNumberNonGaiaPlayers >= 7)
   {
     x7 = rmPlayerLocXFraction(7);
     z7 = rmPlayerLocZFraction(7);
   }

   if(cNumberNonGaiaPlayers >= 8)
   {
     x8 = rmPlayerLocXFraction(8);
     z8 = rmPlayerLocZFraction(8);
   }

 // TRADE POSTS 
 // CASE 1 , TRADEROUTE WILL BE PLACED AT MAPEDGE
 int whichTradeRoute =  rmRandInt(1,2);
 if(whichTradeRoute == 1)
 {
   // MIN = MINIMUM DISTANCE BEWTEEN TP POINT AND PLAYERS  
   // TT = MINIMUM BETWEEN BOTH TP POINTS 
   // TM = MINIMUM ALLOWED TP MIDDLE TO PLAYER 
   // DIF = MINIMUM DIFFERENCE ALLOWED BETWEEN SUM DISTANCE TP POINTS TO PLAYER POINTS
    
   float min = 0.0;
   float mintt = 0.0;
   float mintm = 0.0;
   float maxdd = 0.05;
   float ddm = 0.0;
   float dd12 = 0.0;

   if(cNumberNonGaiaPlayers == 2) 
   {
     min = 0.38;
     mintt = 0.3;
     mintm = 0.45;
   }
   else
   {
     min = 0.24;
     mintt = 0.3;
     mintm = 0.32;
   }

   iterations = 0;

   while((dt1p1 < min) || (dt1p2 < min) || (dt1p3 < min) || (dt1p4 < min) || (dt1p5 < min) || (dt1p6 < min) || (dt1p7 < min) || (dt1p8 < min) || (dt2p1 < min) || (dt2p2 < min) || (dt2p3 < min) || (dt2p4 < min) || (dt2p5 < min) || (dt2p6 < min) || (dt2p7 < min) || (dt2p8 < min) || (dt1t2 < mintt) || (dtmp1 < mintm) || (dtmp2 < mintm) || (dtmp3 < mintm) || (dtmp4 < mintm) || (dtmp5 < mintm) || (dtmp6 < mintm) || (dtmp7 < mintm) || (dtmp8 < mintm) || (ddm > maxdd) || (dd12 > maxdd)) 
   {
      iterations = iterations + 1;
      if(iterations == 10000) break;

      // GET RANDOM VALUES FOR TP ROUTE LOCATION
      tx1 = rmRandFloat(0.14,0.86);
      tz1 = rmRandFloat(0.14,0.86);
      tx2 = rmRandFloat(0.14,0.86);
      tz2 = rmRandFloat(0.14,0.86);

      // GET MIDDLE FROM TP POINTS 
      txm = (tx1+tx2) / 2;
      tzm = (tz1+tz2) / 2;

      // GET DISTANCE TO PLAYERS 
      dt1p1 = sqrt(quad(x1-tx1) + quad(z1-tz1));
      dt1p2 = sqrt(quad(x2-tx1) + quad(z2-tz1));
      dt2p1 = sqrt(quad(x1-tx2) + quad(z1-tz2));
      dt2p2 = sqrt(quad(x2-tx2) + quad(z2-tz2));
      dtmp1 = sqrt(quad(x1-txm) + quad(z1-tzm));
      dtmp2 = sqrt(quad(x2-txm) + quad(z2-tzm));

      // MAKE SURE IN 1V1 TRADEROUTE IS PLACED EXTREMLY FAIR 
      // SUM DISTANCE FROM TP POINTS TO PLAYERS IS ALMOST EQUAL 
      if(cNumberNonGaiaPlayers == 2) 
      {
        ddm = sqrt(quad(dtmp1-dtmp2)); 
        dd12 = sqrt(quad((dt1p1+dt1p2) - (dt2p1+dt2p2)));
      }
   
      if(cNumberNonGaiaPlayers >= 3)
      {
        dt1p3 = sqrt(quad(x3-tx1) + quad(z3-tz1));
        dt1p4 = sqrt(quad(x4-tx1) + quad(z4-tz1));
        dt2p3 = sqrt(quad(x3-tx2) + quad(z3-tz2));
        dt2p4 = sqrt(quad(x4-tx2) + quad(z4-tz2));
        dtmp3 = sqrt(quad(x3-txm) + quad(z3-tzm));
        dtmp4 = sqrt(quad(x4-txm) + quad(z4-tzm));
      }

      if(cNumberNonGaiaPlayers >= 5)
      {
        dt1p5 = sqrt(quad(x5-tx1) + quad(z5-tz1));
        dt1p6 = sqrt(quad(x6-tx1) + quad(z6-tz1));
        dt2p5 = sqrt(quad(x5-tx2) + quad(z5-tz2));
        dt2p6 = sqrt(quad(x6-tx2) + quad(z6-tz2));
        dtmp5 = sqrt(quad(x5-txm) + quad(z5-tzm));
        dtmp6 = sqrt(quad(x6-txm) + quad(z6-tzm));
      }

      if(cNumberNonGaiaPlayers >= 7)
      {
        dt1p7 = sqrt(quad(x7-tx1) + quad(z7-tz1));
        dt1p8 = sqrt(quad(x8-tx1) + quad(z8-tz1));
        dt2p7 = sqrt(quad(x7-tx2) + quad(z7-tz2));
        dt2p8 = sqrt(quad(x8-tx2) + quad(z8-tz2));
        dtmp7 = sqrt(quad(x7-txm) + quad(z7-tzm));
        dtmp8 = sqrt(quad(x8-txm) + quad(z8-tzm));
      }

      dt1t2 = sqrt(quad(tx1-tx2) + quad(tz1-tz2));
   }
 }

   // CASE 2 TRADEROUTE  
   // MIDDLE BETWEEN PLAYERS WILL BE MIDDLE OF TRADEROUTE
   if((whichTradeRoute == 2) || (iterations == 10000))
   {
      txm = (x1+x2+x3+x4+x5+x6+x7+x8) / cNumberNonGaiaPlayers;
      tzm = (z1+z2+z3+z4+z5+z6+z7+z8) / cNumberNonGaiaPlayers;

      // GET RANDOM VALUES FOR TP ROUTE LOCATION
      // STAY AWAY FROM PLAYERS A BIT 
      // SIZE HAS TO BE AT LEAST 0.6 = MEDIUM SIZE
      
      float tmin = 0.0;
      if((cNumberNonGaiaPlayers == 5) || (cNumberNonGaiaPlayers == 7))
        tmin = 0.1;
      else
        tmin = 0.18;

      while((dt1p1 < tmin) || (dt1p2 < tmin) || (dt1p3 < tmin) || (dt1p4 < tmin) || (dt1p5 < tmin) || (dt1p6 < tmin) || (dt1p7 < tmin) || (dt1p8 < tmin) || (dt2p1 < tmin) || (dt2p2 < tmin) || (dt2p3 < tmin) || (dt2p4 < tmin) || (dt2p5 < tmin) || (dt2p6 < tmin) || (dt2p7 < tmin) || (dt2p8 < tmin) || (dt1t2 < 0.6))
      {
        // MAKE SURE TRADEROUTE DOESNT GET PLACED OUTSIDE MAP
        tx2 = 0;
        tz2 = 0;
        while((tx2 < 0.15) || (tx2 > 0.85) || (tz2 < 0.15) || (tz2 > 0.85))
        {
          tx1 = rmRandFloat(0.15,0.85);
          tz1 = rmRandFloat(0.15,0.85);
          tx2 = txm + (txm-tx1);
          tz2 = tzm + (tzm-tz1);
        }  

        // GET DISTANCE TO PLAYERS
        dt1p1 = sqrt(quad(tx1-x1)+quad(tz1-z1));
        dt1p2 = sqrt(quad(tx1-x2)+quad(tz1-z2));
        dt2p1 = sqrt(quad(tx2-x1)+quad(tz2-z1));
        dt2p2 = sqrt(quad(tx2-x2)+quad(tz2-z2));
	
	if(cNumberNonGaiaPlayers >= 3)
        {
          dt1p3 = sqrt(quad(tx1-x3)+quad(tz1-z3));
          dt1p4 = sqrt(quad(tx1-x4)+quad(tz1-z4));
          dt2p3 = sqrt(quad(tx2-x3)+quad(tz2-z3));
          dt2p4 = sqrt(quad(tx2-x4)+quad(tz2-z4));
        }

	if(cNumberNonGaiaPlayers >= 5)
        {
          dt1p5 = sqrt(quad(tx1-x5)+quad(tz1-z5));
          dt1p6 = sqrt(quad(tx1-x6)+quad(tz1-z6));
          dt2p5 = sqrt(quad(tx2-x5)+quad(tz2-z5));
          dt2p6 = sqrt(quad(tx2-x6)+quad(tz2-z6));
        }

	if(cNumberNonGaiaPlayers >= 7)
        {
          dt1p7 = sqrt(quad(tx1-x7)+quad(tz1-z7));
          dt1p8 = sqrt(quad(tx1-x8)+quad(tz1-z8));
          dt2p7 = sqrt(quad(tx2-x7)+quad(tz2-z7));
          dt2p8 = sqrt(quad(tx2-x8)+quad(tz2-z8));
        }

        dt1t2 = sqrt(quad(tx1-tx2)+quad(tz1-tz2));
      }
   }
      
     // TRADE ROUTE
     int tradeRouteID = rmCreateTradeRoute();
     rmAddTradeRouteWaypoint(tradeRouteID, tx1, tz1);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 8 * 7, tzm - (tzm-tz1) / 8 * 7);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 4 * 3, tzm - (tzm-tz1) / 4 * 3);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 8 * 5, tzm - (tzm-tz1) / 8 * 5);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 2, tzm - (tzm-tz1) / 2);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 8 * 3, tzm - (tzm-tz1) / 8 * 3);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 4, tzm - (tzm-tz1) / 4);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx1) / 8, tzm - (tzm-tz1) / 8);
     rmAddTradeRouteWaypoint(tradeRouteID, txm, tzm);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 8, tzm - (tzm-tz2) / 8);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 4, tzm - (tzm-tz2) / 4);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 8 * 3 , tzm - (tzm-tz2) / 8 * 3);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 2, tzm - (tzm-tz2) / 2);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 8 * 5 , tzm - (tzm-tz2) / 8 * 5);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 4 * 3 , tzm - (tzm-tz2) / 4 * 3);
     rmAddTradeRouteWaypoint(tradeRouteID, txm - (txm-tx2) / 8 * 7 , tzm - (tzm-tz2) / 8 * 7);
     rmAddTradeRouteWaypoint(tradeRouteID, tx2, tz2);
     rmBuildTradeRoute(tradeRouteID, "dirt");

     int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
     rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
     rmSetObjectDefAllowOverlap(socketID, true);
     rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
     rmSetObjectDefMinDistance(socketID, 0.0);
     rmSetObjectDefMaxDistance(socketID, 8.0);
     rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

     // 4 TPS FOR LARGE TRADEROUTES
     vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.1);
     rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
     if(dt1t2 > 0.72)
     {
       socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
       rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
       socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
       rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
     }
     socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.9);
     rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

 // INDIANS
 if(cNumberNonGaiaPlayers == 2)
 { 
   float ix1 = 0.0;
   float iz1 = 0.0;
   float ix2 = 0.0;
   float iz2 = 0.0;

   float di1p1 = 0.0;
   float di1p2 = 0.0;
   float di2p1 = 0.0;
   float di2p2 = 0.0;
   float di1i2 = 0.0;
   float di1t1 = 0.0;
   float di1t2 = 0.0;
   float di2t1 = 0.0;
   float di2t2 = 0.0;
   float di1tm = 0.0;
   float di2tm = 0.0;
   float idd = 1.0;

   // MIN = MINIMUM DISTANCE BETWEEN PLAYERS AND INDIAN SETTLEMENTS 
   // II = MINIMUM DISTANCE BETWEEN INDIAN EACH OTHER 
   // TP = MINIMUM DISTANCE TO TRADEROUTE
   // DIF = MINIMUM DIFFERENCE BETWEEN DISTANCE INDIAN TO PLAYERS SUM 

   float imin = 0.4;
   float iminii = 0.25;
   float imintp = 0.0;
   float imindif = 0.05;
   iterations = 0;

   while((di1p1 < imin) || (di1p2 < imin) || (di2p1 < imin) || (di2p2 < imin) || (di1i2 < iminii) || (di1t1 < imintp) || (di1t2 < imintp) || (di2t1 < imintp) || (di2t2 < imintp) || (di1tm < imintp) || (di2tm < imintp) || (idd > imindif)) 
   {
      // SOMETIMES NOT ENOUGH SPACE TO PLACE INDIANS FAIR -> PLACE NONE 
      iterations = iterations + 1;
      if(iterations == 10000) imin = 0.38;
      if(iterations == 20000) imin = 0.36;
      if(iterations == 30000) imin = 0.34;
      if(iterations == 40000) imin = 0.32;     
      if(iterations == 50000) break;

      ix1 = rmRandFloat(0.2,0.8);
      iz1 = rmRandFloat(0.2,0.8);
      ix2 = rmRandFloat(0.2,0.8);
      iz2 = rmRandFloat(0.2,0.8);

      // GET DISTANCE TO PLAYERS 
      di1p1 = sqrt(quad(x1-ix1) + quad(z1-iz1));
      di1p2 = sqrt(quad(x2-ix1) + quad(z2-iz1));
      di2p1 = sqrt(quad(x1-ix2) + quad(z1-iz2));
      di2p2 = sqrt(quad(x2-ix2) + quad(z2-iz2));
      di1i2 = sqrt(quad(ix1-ix2) + quad(iz1-iz2));
      di1t1 = sqrt(quad(tx1-ix1) + quad(tz1-iz1));
      di1t2 = sqrt(quad(tx2-ix1) + quad(tz2-iz1));
      di2t1 = sqrt(quad(tx1-ix2) + quad(tz1-iz2));
      di2t2 = sqrt(quad(tx2-ix2) + quad(tz2-iz2));
      di1tm = sqrt(quad(txm-ix1) + quad(tzm-iz1));
      di2tm = sqrt(quad(txm-ix2) + quad(tzm-iz2));
      idd = sqrt(quad((di1p1 + di2p1) - (di1p2 + di2p2)));
   }
   
   if(iterations != 10000)
   {
     int comancheVillageAID = -1;
     int comancheVillageType = rmRandInt(1,5);
     if(tribes == 0) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Apache village "+comancheVillageType);
     if(tribes == 1) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Comanche village "+comancheVillageType);
     if(tribes == 2) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Tupi village "+comancheVillageType);
     if(tribes == 3) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Cree village "+comancheVillageType);
     if(tribes == 4) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Cherokee village "+comancheVillageType);
     if(tribes == 5) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Maya village "+comancheVillageType);
     if(tribes == 6) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Navajo village "+comancheVillageType);
     if(tribes == 7) 
       comancheVillageAID = rmCreateGrouping("comanche village A", "native Zapotec village "+comancheVillageType);
     rmSetGroupingMinDistance(comancheVillageAID, 0.0);
     rmSetGroupingMaxDistance(comancheVillageAID, rmXFractionToMeters(0.13));
     rmAddGroupingConstraint(comancheVillageAID, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageAID, avoidSocket);
     rmAddGroupingConstraint(comancheVillageAID, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageAID, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageAID, avoidNatives);
     rmAddGroupingConstraint(comancheVillageAID, avoidStartingUnits);
     rmPlaceGroupingAtLoc(comancheVillageAID, 0, ix1, iz1);

     int comancheVillageBID = -1;
     if(tribes == 0) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Apache village "+comancheVillageType);
     if(tribes == 1) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Comanche village "+comancheVillageType);
     if(tribes == 2) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Tupi village "+comancheVillageType);
     if(tribes == 3) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Cree village "+comancheVillageType);
     if(tribes == 4) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Cherokee village "+comancheVillageType);
     if(tribes == 5) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Maya village "+comancheVillageType);
     if(tribes == 6) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Navajo village "+comancheVillageType);
     if(tribes == 7) 
       comancheVillageBID = rmCreateGrouping("comanche village B", "native Zapotec village "+comancheVillageType);
     rmSetGroupingMinDistance(comancheVillageBID, 0.0);
     rmSetGroupingMaxDistance(comancheVillageBID, rmXFractionToMeters(0.13));
     rmAddGroupingConstraint(comancheVillageBID, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageBID, avoidSocket);
     rmAddGroupingConstraint(comancheVillageBID, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageBID, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageBID, avoidNatives);
     rmAddGroupingConstraint(comancheVillageBID, avoidStartingUnits);
     rmPlaceGroupingAtLoc(comancheVillageBID, 0, ix2, iz2);
   }

     // MOVE THOSE INDIANS MORE TOWARDS THE EDGE
     float ix3 = x1;
     float iz3 = z1;
     float ix4 = x2;
     float iz4 = z2;
     float dEdge = 0.1;

     if(x1 < 0.5) 
        ix3 = ix3 - dEdge;
     else
        ix3 = ix3 + dEdge;

     if(z1 < 0.5) 
        iz3 = iz3 - dEdge;
     else
        iz3 = iz3 + dEdge;

     if(x2 < 0.5) 
        ix4 = ix4 - dEdge;
     else
        ix4 = ix4 + dEdge;

     if(z2 < 0.5) 
        iz4 = iz4 - dEdge;
     else
        iz4 = iz4 + dEdge;

     int comancheVillageCID = -1; 
     if(tribes == 0) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Comanche village "+comancheVillageType);
     if(tribes == 1) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Apache village "+comancheVillageType);
     if(tribes == 2) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Cherokee village "+comancheVillageType);
     if(tribes == 3) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Maya village "+comancheVillageType);
     if(tribes == 4) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Tupi village "+comancheVillageType);
     if(tribes == 5) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Cree village "+comancheVillageType);
     if(tribes == 6) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Zapotec village "+comancheVillageType);
     if(tribes == 7) 
       comancheVillageCID = rmCreateGrouping("comanche village C", "native Navajo village "+comancheVillageType);
     rmSetGroupingMinDistance(comancheVillageCID, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageCID, rmXFractionToMeters(0.3));
     rmAddGroupingConstraint(comancheVillageCID, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageCID, avoidSocket);
     rmAddGroupingConstraint(comancheVillageCID, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageCID, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageCID, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageCID, avoidNatives);
     rmAddGroupingConstraint(comancheVillageCID, avoidStartingUnits);
     rmPlaceGroupingAtLoc(comancheVillageCID, 0, ix3, iz3);

     int comancheVillageDID = -1; 
     if(tribes == 0) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Comanche village "+comancheVillageType);
     if(tribes == 1) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Apache village "+comancheVillageType);
     if(tribes == 2) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Cherokee village "+comancheVillageType);
     if(tribes == 3) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Maya village "+comancheVillageType);
     if(tribes == 4) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Tupi village "+comancheVillageType);
     if(tribes == 5) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Cree village "+comancheVillageType);
     if(tribes == 6) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Zapotec village "+comancheVillageType);
     if(tribes == 7) 
       comancheVillageDID = rmCreateGrouping("comanche village D", "native Navajo village "+comancheVillageType);
     rmSetGroupingMinDistance(comancheVillageDID, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageDID, rmXFractionToMeters(0.3));
     rmAddGroupingConstraint(comancheVillageDID, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageDID, avoidSocket);
     rmAddGroupingConstraint(comancheVillageDID, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageDID, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageDID, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageDID, avoidNatives);
     rmAddGroupingConstraint(comancheVillageDID, avoidStartingUnits);
     rmPlaceGroupingAtLoc(comancheVillageDID, 0, ix4, iz4);
  }


   if(cNumberNonGaiaPlayers >= 3)
   {
     float middlex = (x1+x2+x3+x4+x5+x6+x7+x8) / cNumberNonGaiaPlayers;
     float middlez = (z1+z2+z3+z4+z5+z6+z7+z8) / cNumberNonGaiaPlayers;

     // INDIANS AT CENTER
     int IndianAID=rmCreateArea("Indian A");
     rmSetAreaSize(IndianAID, 0.05, 0.05);	
     rmSetAreaCoherence(IndianAID, 1.0);
     rmSetAreaTerrainType(IndianAID, "carolina_grass");
     rmSetAreaBaseHeight(IndianAID, 6.0);   
     if(centerIndianSetup == 1)
       rmSetAreaLocation(IndianAID,middlex-0.09,middlez-0.09);
     else
       rmSetAreaLocation(IndianAID,middlex-0.09,middlez+0.09);
     rmBuildArea(IndianAID);

     int IndianBID=rmCreateArea("Indian B");	
     rmSetAreaSize(IndianBID, 0.05, 0.05);
     rmSetAreaCoherence(IndianBID, 1.0);
     rmSetAreaTerrainType(IndianBID, "carolina_grass");
     rmSetAreaBaseHeight(IndianBID, 6.0);  
     if(centerIndianSetup == 1)
       rmSetAreaLocation(IndianBID,middlex+0.09,middlez+0.09);
     else
       rmSetAreaLocation(IndianBID,middlex+0.09,middlez-0.09);
     rmBuildArea(IndianBID);

     int comancheVillageAID4 = -1;
     int comancheVillageType4 = rmRandInt(1,5);
     if(tribes == 0) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Apache village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Comanche village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Tupi village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Cree village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Maya village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Navajo village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageAID4 = rmCreateGrouping("comanche village A4", "native Zapotec village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageAID4, 0.0);
     rmSetGroupingMaxDistance(comancheVillageAID4, rmXFractionToMeters(0.18));
     rmAddGroupingConstraint(comancheVillageAID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageAID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageAID4, avoidTC4Plus);
     rmAddGroupingConstraint(comancheVillageAID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageAID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageAID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageAID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageAID4, 0, IndianAID);

     int comancheVillageBID4 = -1;
     if(tribes == 0) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Apache village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Comanche village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Tupi village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Cree village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Maya village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Navajo village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageBID4 = rmCreateGrouping("comanche village B4", "native Zapotec village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageBID4, 0.0);
     rmSetGroupingMaxDistance(comancheVillageBID4, rmXFractionToMeters(0.18));
     rmAddGroupingConstraint(comancheVillageBID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageBID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageBID4, avoidTC4Plus);
     rmAddGroupingConstraint(comancheVillageBID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageBID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageBID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageBID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageBID4, 0, IndianBID);

     // INDIANS AT CARDINAL DIRECTIONS MORE TO THE EDGE
     int IndianCID=rmCreateArea("Indian C");
     rmSetAreaSize(IndianCID, 0.1, 0.1);	
     rmSetAreaCoherence(IndianCID, 1.0);
     rmSetAreaTerrainType(IndianCID, "carolina_grass");
     rmSetAreaBaseHeight(IndianCID, 6.0); 
     if(edgeIndianSetup == 1)  
       rmSetAreaLocation(IndianCID, 0.12, 0.5);
     else 
       rmSetAreaLocation(IndianCID, 0.25, 0.75);
     rmBuildArea(IndianCID);

     int IndianDID=rmCreateArea("Indian D");
     rmSetAreaSize(IndianDID, 0.1, 0.1);	
     rmSetAreaCoherence(IndianDID, 1.0);
     rmSetAreaTerrainType(IndianDID, "carolina_grass");
     rmSetAreaBaseHeight(IndianDID, 6.0);   
     if(edgeIndianSetup == 1) 
       rmSetAreaLocation(IndianDID, 0.88, 0.5);
     else 
       rmSetAreaLocation(IndianDID, 0.75, 0.25);
     rmBuildArea(IndianDID);

     int IndianEID=rmCreateArea("Indian E");
     rmSetAreaSize(IndianEID, 0.1, 0.1);	
     rmSetAreaCoherence(IndianEID, 1.0);
     rmSetAreaTerrainType(IndianEID, "carolina_grass");
     rmSetAreaBaseHeight(IndianEID, 6.0); 
     if(edgeIndianSetup == 1) 
       rmSetAreaLocation(IndianEID, 0.5, 0.12);
     else
       rmSetAreaLocation(IndianEID, 0.25, 0.25);
     rmBuildArea(IndianEID);

     int IndianFID=rmCreateArea("Indian F");
     rmSetAreaSize(IndianFID, 0.1, 0.1);	
     rmSetAreaCoherence(IndianFID, 1.0);
     rmSetAreaTerrainType(IndianFID, "carolina_grass");
     rmSetAreaBaseHeight(IndianFID, 6.0);  
     if(edgeIndianSetup == 1)  
       rmSetAreaLocation(IndianFID, 0.5, 0.88);
     else
       rmSetAreaLocation(IndianFID, 0.75, 0.75);
     rmBuildArea(IndianFID);


     int comancheVillageCID4 = -1; 
     if(tribes == 0) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Comanche village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Apache village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Maya village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Tupi village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Cree village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Zapotec village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageCID4 = rmCreateGrouping("comanche village C4", "native Navajo village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageCID4, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageCID4, rmXFractionToMeters(0.5));
     rmAddGroupingConstraint(comancheVillageCID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageCID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageCID4, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageCID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageCID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageCID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageCID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageCID4, 0, IndianCID);

     int comancheVillageDID4 = -1; 
     if(tribes == 0) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Comanche village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Apache village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Maya village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Tupi village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Cree village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Zapotec village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageDID4 = rmCreateGrouping("comanche village D4", "native Navajo village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageDID4, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageDID4, rmXFractionToMeters(0.5));
     rmAddGroupingConstraint(comancheVillageDID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageDID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageDID4, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageDID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageDID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageDID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageDID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageDID4, 0, IndianDID);

     int comancheVillageEID4 = -1; 
     if(tribes == 0) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Comanche village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Apache village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Maya village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Tupi village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Cree village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Zapotec village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageEID4 = rmCreateGrouping("comanche village E4", "native Navajo village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageEID4, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageEID4, rmXFractionToMeters(0.5));
     rmAddGroupingConstraint(comancheVillageEID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageEID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageEID4, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageEID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageEID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageEID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageEID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageEID4, 0, IndianEID);

     int comancheVillageFID4 = -1; 
     if(tribes == 0) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Comanche village "+comancheVillageType4);
     if(tribes == 1) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Apache village "+comancheVillageType4);
     if(tribes == 2) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Cherokee village "+comancheVillageType4);
     if(tribes == 3) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Maya village "+comancheVillageType4);
     if(tribes == 4) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Tupi village "+comancheVillageType4);
     if(tribes == 5) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Cree village "+comancheVillageType4);
     if(tribes == 6) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Zapotec village "+comancheVillageType4);
     if(tribes == 7) 
       comancheVillageFID4 = rmCreateGrouping("comanche village F4", "native Navajo village "+comancheVillageType4);
     rmSetGroupingMinDistance(comancheVillageFID4, rmXFractionToMeters(0.0));
     rmSetGroupingMaxDistance(comancheVillageFID4, rmXFractionToMeters(0.5));
     rmAddGroupingConstraint(comancheVillageFID4, avoidTradeRoute);
     rmAddGroupingConstraint(comancheVillageFID4, avoidSocket);
     rmAddGroupingConstraint(comancheVillageFID4, avoidTCFar);
     rmAddGroupingConstraint(comancheVillageFID4, circleIndianConstraint);
     rmAddGroupingToClass(comancheVillageFID4, rmClassID("natives"));
     rmAddGroupingConstraint(comancheVillageFID4, avoidNatives);
     rmAddGroupingConstraint(comancheVillageFID4, avoidStartingUnits);
     rmPlaceGroupingInArea(comancheVillageFID4, 0, IndianFID);
   }

   // FOREST 
   int numForest = -1;
   int failCount = -1;
   numForest=28 + cNumberNonGaiaPlayers;  
   failCount=0;

   for (i=0; <numForest)
   {   
      int Forest=rmCreateArea("Forest"+i);
      rmSetAreaSize(Forest, rmAreaTilesToFraction(220), rmAreaTilesToFraction(250));
      rmSetAreaForestType(Forest, "Great Plains Forest");
      rmSetAreaForestDensity(Forest, 1.0);
      rmSetAreaForestClumpiness(Forest, 1.0);
      rmSetAreaForestUnderbrush(Forest, 0.0);
      rmSetAreaMinBlobs(Forest, 2);
      rmSetAreaMaxBlobs(Forest, 3);
      rmSetAreaMinBlobDistance(Forest, 4.0);
      rmSetAreaMaxBlobDistance(Forest, 8.0);
      rmSetAreaCoherence(Forest, 0.7);
      rmSetAreaSmoothDistance(Forest, 0);		   
      rmAddAreaConstraint(Forest, playerConstraintForest);											
      rmAddAreaConstraint(Forest, avoidTradeRoute);
      rmAddAreaConstraint(Forest, avoidNativesSmall);
      if(rmBuildArea(Forest)==false)
      {  
         failCount++;
	 if(failCount==5)
	    break;
      }
      else
         failCount=0; 
   }

   // RESOURCES PER PLAYER 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false,2);

   int StartHuntID=rmCreateObjectDef("starting hunt");
   rmAddObjectDefItem(StartHuntID, "elk", 6, 12.0);
   rmSetObjectDefMinDistance(StartHuntID, 15);
   rmSetObjectDefMaxDistance(StartHuntID, 20);
   rmAddObjectDefToClass(StartHuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(StartHuntID, circleConstraint);
   rmAddObjectDefConstraint(StartHuntID, avoidStartResource);
   rmAddObjectDefConstraint(StartHuntID, avoidNativesSmall);
   rmAddObjectDefConstraint(StartHuntID, avoidAll);
   rmSetObjectDefCreateHerd(StartHuntID, true);
   rmPlaceObjectDefPerPlayer(StartHuntID, false,1);

   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidNativesSmall);
   rmAddObjectDefConstraint(playerGoldID, circleConstraint);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmSetObjectDefMinDistance(playerGoldID, 20.0);
   rmSetObjectDefMaxDistance(playerGoldID, 30.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false,1);

   int playerSheepID=rmCreateObjectDef("player sheep");
   rmAddObjectDefItem(playerSheepID, "sheep", 2, 3.0);
   rmAddObjectDefConstraint(playerSheepID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerSheepID, avoidSheep);
   rmAddObjectDefConstraint(playerSheepID, avoidNativesSmall);
   rmAddObjectDefConstraint(playerSheepID, circleConstraint);
   rmAddObjectDefConstraint(playerSheepID, avoidAll);
   rmSetObjectDefMinDistance(playerSheepID, 20.0);
   rmSetObjectDefMaxDistance(playerSheepID, 25.0);
   rmPlaceObjectDefPerPlayer(playerSheepID, false,1);

   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidNativesSmall);
   rmAddObjectDefConstraint(GoldMediumID, circleConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmSetObjectDefMinDistance(GoldMediumID, 40.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 50.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false,1);

   int HuntMediumID=rmCreateObjectDef("med hunt");
   rmAddObjectDefItem(HuntMediumID, "elk", 7, 15.0);
   rmSetObjectDefMinDistance(HuntMediumID, 40);
   rmSetObjectDefMaxDistance(HuntMediumID, 50);
   rmAddObjectDefToClass(HuntMediumID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntMediumID, circleConstraint);
   rmAddObjectDefConstraint(HuntMediumID, huntAvoidHunt);
   rmAddObjectDefConstraint(HuntMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(HuntMediumID, avoidNativesSmall);
   rmAddObjectDefConstraint(HuntMediumID, avoidAll);
   rmSetObjectDefCreateHerd(HuntMediumID, true);
   rmPlaceObjectDefPerPlayer(HuntMediumID, false,1);

   int HuntFarID=rmCreateObjectDef("far hunt");
   rmAddObjectDefItem(HuntFarID, "moose", 7, 15.0);
   rmSetObjectDefMinDistance(HuntFarID, 60);
   rmSetObjectDefMaxDistance(HuntFarID, 70);
   rmAddObjectDefToClass(HuntFarID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntFarID, circleConstraint);
   rmAddObjectDefConstraint(HuntFarID, huntAvoidHunt);
   rmAddObjectDefConstraint(HuntFarID, avoidTradeRoute);
   rmAddObjectDefConstraint(HuntFarID, avoidNativesSmall);
   rmAddObjectDefConstraint(HuntFarID, avoidAll);
   rmSetObjectDefCreateHerd(HuntFarID, true);
   rmPlaceObjectDefPerPlayer(HuntFarID, false,2);

   int MediumSheepID=rmCreateObjectDef("medium sheep");
   rmAddObjectDefItem(MediumSheepID, "sheep", 2, 3.0);
   rmAddObjectDefConstraint(MediumSheepID, avoidTradeRoute);
   rmAddObjectDefConstraint(MediumSheepID, avoidSheep);
   rmAddObjectDefConstraint(MediumSheepID, avoidNativesSmall);
   rmAddObjectDefConstraint(MediumSheepID, circleConstraint);
   rmAddObjectDefConstraint(MediumSheepID, avoidAll);
   rmSetObjectDefMinDistance(MediumSheepID, 45.0);
   rmSetObjectDefMaxDistance(MediumSheepID, 60.0);
   rmPlaceObjectDefPerPlayer(MediumSheepID, false,1);

   int FarSheepID=rmCreateObjectDef("far sheep");
   rmAddObjectDefItem(FarSheepID, "sheep", 2, 3.0);
   rmAddObjectDefConstraint(FarSheepID, avoidTradeRoute);
   rmAddObjectDefConstraint(FarSheepID, avoidSheep);
   rmAddObjectDefConstraint(FarSheepID, avoidNativesSmall);
   rmAddObjectDefConstraint(FarSheepID, circleConstraint);
   rmAddObjectDefConstraint(FarSheepID, avoidAll);
   rmSetObjectDefMinDistance(FarSheepID, 80.0);
   rmSetObjectDefMaxDistance(FarSheepID, 90.0);
   rmPlaceObjectDefPerPlayer(FarSheepID, false,1);

   // ADDITIONAL RESOURCES PLACED INTO CARDINAL DIRECTIONS 
   int northEastGoldID=rmCreateObjectDef("ne gold");
   rmAddObjectDefItem(northEastGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(northEastGoldID, 0.0);
   rmSetObjectDefMaxDistance(northEastGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(northEastGoldID, avoidTC);
   rmAddObjectDefConstraint(northEastGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(northEastGoldID, avoidNativesSmall);
   rmAddObjectDefConstraint(northEastGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(northEastGoldID, avoidAll);
   rmAddObjectDefConstraint(northEastGoldID, circleConstraint);
   rmAddObjectDefConstraint(northEastGoldID, Northward);
   rmAddObjectDefConstraint(northEastGoldID, Eastward);
   rmPlaceObjectDefAtLoc(northEastGoldID, 0, 0.5, 0.5, 2);

   int northWestGoldID=rmCreateObjectDef("nw gold");
   rmAddObjectDefItem(northWestGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(northWestGoldID, 0.0);
   rmSetObjectDefMaxDistance(northWestGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(northWestGoldID, avoidTC);
   rmAddObjectDefConstraint(northWestGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(northWestGoldID, avoidNativesSmall);
   rmAddObjectDefConstraint(northWestGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(northWestGoldID, avoidAll);
   rmAddObjectDefConstraint(northWestGoldID, circleConstraint);
   rmAddObjectDefConstraint(northWestGoldID, Northward);
   rmAddObjectDefConstraint(northWestGoldID, Westward);
   rmPlaceObjectDefAtLoc(northWestGoldID, 0, 0.5, 0.5, 2);

   int southEastGoldID=rmCreateObjectDef("se gold");
   rmAddObjectDefItem(southEastGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(southEastGoldID, 0.0);
   rmSetObjectDefMaxDistance(southEastGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(southEastGoldID, avoidTC);
   rmAddObjectDefConstraint(southEastGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(southEastGoldID, avoidNativesSmall);
   rmAddObjectDefConstraint(southEastGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(southEastGoldID, avoidAll);
   rmAddObjectDefConstraint(southEastGoldID, circleConstraint);
   rmAddObjectDefConstraint(southEastGoldID, Southward);
   rmAddObjectDefConstraint(southEastGoldID, Eastward);
   rmPlaceObjectDefAtLoc(southEastGoldID, 0, 0.5, 0.5, 2);

   int southWestGoldID=rmCreateObjectDef("sw gold");
   rmAddObjectDefItem(southWestGoldID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(southWestGoldID, 0.0);
   rmSetObjectDefMaxDistance(southWestGoldID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(southWestGoldID, avoidTC);
   rmAddObjectDefConstraint(southWestGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(southWestGoldID, avoidNativesSmall);
   rmAddObjectDefConstraint(southWestGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(southWestGoldID, avoidAll);
   rmAddObjectDefConstraint(southWestGoldID, circleConstraint);
   rmAddObjectDefConstraint(southWestGoldID, Southward);
   rmAddObjectDefConstraint(southWestGoldID, Westward);
   rmPlaceObjectDefAtLoc(southWestGoldID, 0, 0.5, 0.5, 2);

   // HUNTABLES 
   int northEastHuntID=rmCreateObjectDef("ne hunt");
   rmAddObjectDefItem(northEastHuntID, "moose", 7, 15.0);
   rmSetObjectDefMinDistance(northEastHuntID, 0.0);
   rmSetObjectDefMaxDistance(northEastHuntID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(northEastHuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(northEastHuntID, avoidTC);
   rmAddObjectDefConstraint(northEastHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(northEastHuntID, avoidNativesSmall);
   rmAddObjectDefConstraint(northEastHuntID, huntAvoidHunt);
   rmAddObjectDefConstraint(northEastHuntID, avoidAll);
   rmAddObjectDefConstraint(northEastHuntID, circleConstraint);
   rmAddObjectDefConstraint(northEastHuntID, Northward);
   rmAddObjectDefConstraint(northEastHuntID, Eastward);
   rmSetObjectDefCreateHerd(northEastHuntID, true);
   rmPlaceObjectDefAtLoc(northEastHuntID, 0, 0.5, 0.5, 2);

   int northWestHuntID=rmCreateObjectDef("nw hunt");
   rmAddObjectDefItem(northWestHuntID, "elk", 7, 15.0);
   rmSetObjectDefMinDistance(northWestHuntID, 0.0);
   rmSetObjectDefMaxDistance(northWestHuntID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(northWestHuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(northWestHuntID, avoidTC);
   rmAddObjectDefConstraint(northWestHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(northWestHuntID, avoidNativesSmall);
   rmAddObjectDefConstraint(northWestHuntID, huntAvoidHunt);
   rmAddObjectDefConstraint(northWestHuntID, avoidAll);
   rmAddObjectDefConstraint(northWestHuntID, circleConstraint);
   rmAddObjectDefConstraint(northWestHuntID, Northward);
   rmAddObjectDefConstraint(northWestHuntID, Westward);
   rmSetObjectDefCreateHerd(northWestHuntID, true);
   rmPlaceObjectDefAtLoc(northWestHuntID, 0, 0.5, 0.5, 2);

   int southEastHuntID=rmCreateObjectDef("se hunt");
   rmAddObjectDefItem(southEastHuntID, "elk", 7, 15.0);
   rmSetObjectDefMinDistance(southEastHuntID, 0.0);
   rmSetObjectDefMaxDistance(southEastHuntID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(southEastHuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(southEastHuntID, avoidTC);
   rmAddObjectDefConstraint(southEastHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(southEastHuntID, avoidNativesSmall);
   rmAddObjectDefConstraint(southEastHuntID, huntAvoidHunt);
   rmAddObjectDefConstraint(southEastHuntID, avoidAll);
   rmAddObjectDefConstraint(southEastHuntID, circleConstraint);
   rmAddObjectDefConstraint(southEastHuntID, Southward);
   rmAddObjectDefConstraint(southEastHuntID, Eastward);
   rmSetObjectDefCreateHerd(southEastHuntID, true);
   rmPlaceObjectDefAtLoc(southEastHuntID, 0, 0.5, 0.5, 2);

   int southWestHuntID=rmCreateObjectDef("sw hunt");
   rmAddObjectDefItem(southWestHuntID, "moose", 7, 15.0);
   rmSetObjectDefMinDistance(southWestHuntID, 0.0);
   rmSetObjectDefMaxDistance(southWestHuntID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(southWestHuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(southWestHuntID, avoidTC);
   rmAddObjectDefConstraint(southWestHuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(southWestHuntID, avoidNativesSmall);
   rmAddObjectDefConstraint(southWestHuntID, huntAvoidHunt);
   rmAddObjectDefConstraint(southWestHuntID, avoidAll);
   rmAddObjectDefConstraint(southWestHuntID, circleConstraint);
   rmAddObjectDefConstraint(southWestHuntID, Southward);
   rmAddObjectDefConstraint(southWestHuntID, Westward);
   rmSetObjectDefCreateHerd(southWestHuntID, true);
   rmPlaceObjectDefAtLoc(southWestHuntID, 0, 0.5, 0.5, 2);

   // Treasures
   int nugget1= rmCreateObjectDef("nugget easy"); 
   rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(1, 1);
   rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget1, avoidNativesSmall);
   rmAddObjectDefConstraint(nugget1, avoidNuggets);
   rmAddObjectDefConstraint(nugget1, avoidAll);
   rmAddObjectDefConstraint(nugget1, circleConstraint);
   rmAddObjectDefToClass(nugget1, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget1, 25.0);
   rmSetObjectDefMaxDistance(nugget1, 35.0);
   rmPlaceObjectDefPerPlayer(nugget1, false, 2);

   int nugget2= rmCreateObjectDef("nugget med"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget2, avoidNativesSmall);
   rmAddObjectDefConstraint(nugget2, avoidTC);
   rmAddObjectDefConstraint(nugget2, avoidNuggets);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmAddObjectDefConstraint(nugget2, circleConstraint);
   rmAddObjectDefToClass(nugget2, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget2, 50.0);
   rmSetObjectDefMaxDistance(nugget2, 75.0);
   rmPlaceObjectDefPerPlayer(nugget2, false, 1);

   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget3, avoidNativesSmall);
   rmAddObjectDefConstraint(nugget3, avoidTC);
   rmAddObjectDefConstraint(nugget3, avoidNuggets);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmAddObjectDefConstraint(nugget3, circleConstraint);
   rmAddObjectDefToClass(nugget3, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget3, 70.0);
   rmSetObjectDefMaxDistance(nugget3, 90.0);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   int nuggetIndi=rmCreateObjectDef("free nugget");
   rmAddObjectDefItem(nuggetIndi,  "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefConstraint(nuggetIndi, avoidTradeRoute);
   rmAddObjectDefConstraint(nuggetIndi, avoidNativesSmall);
   rmAddObjectDefConstraint(nuggetIndi, avoidAll);
   rmAddObjectDefConstraint(nuggetIndi, avoidNuggetsFar);
   rmAddObjectDefConstraint(nuggetIndi, circleConstraint);
   rmAddObjectDefToClass(nuggetIndi, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nuggetIndi, 0.0);
   rmSetObjectDefMaxDistance(nuggetIndi, rmXFractionToMeters(0.5));
   rmPlaceObjectDefAtLoc(nuggetIndi, 0, 0.5, 0.5,2);

   // PLAYER INDEPENDENT RESOURCES
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, "TreeGreatPlains", 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmSetObjectDefMinDistance(StragglerTreeID, 0.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <cNumberNonGaiaPlayers*15)
     rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);
}  


