
// TOWER NOMAD TWC
// OKTOBER 2006 BY MARTIN 'ORCA' SCHMIDT

void main(void)
{
   // MAPSIZE 
   int playerTiles = 14000;
   if(cNumberNonGaiaPlayers == 2) 
     playerTiles=15000;
   if(cNumberNonGaiaPlayers == 4) 
     playerTiles=14000;
   if(cNumberNonGaiaPlayers == 6) 
     playerTiles=13000;
   if(cNumberNonGaiaPlayers == 8) 
     playerTiles=12500;

   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1);
	
   // TERRAIN 
   rmSetSeaLevel(0.0);
   rmSetLightingSet("carolina");
   rmSetSeaType("great lakes");
   rmTerrainInitialize("water");

   // THIS LINES MUST BE HERE FOR TREASURES
   rmSetMapType("carolina");
   rmSetMapType("grass");
   rmSetMapType("water");

   // CLASSES
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classForest");
   rmDefineClass("classStartObject");
   rmDefineClass("huntables");
   rmDefineClass("classNugget");
   rmDefineClass("classNatives");
   rmDefineClass("abstractExplorer");
   
   int whichTribe = rmRandInt(1,2);
   if(whichTribe == 1)
     rmSetSubCiv(0, "caribs");
   else
     rmSetSubCiv(0, "Huron");

   // CONSTRAINTS
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
   int avoidStartingUnits=rmCreateClassDistanceConstraint("avoid start obj", rmClassID("classStartObject"), 10.0);
   int avoidStartingUnitsMed=rmCreateClassDistanceConstraint("avoid start obj med", rmClassID("classStartObject"), 15.0);
   int avoidStartingUnitsFar=rmCreateClassDistanceConstraint("avoid start obj far", rmClassID("classStartObject"), 30.0);
   int edgeConstraint=rmCreatePieConstraint("things avoid edge", 0.5, 0.5, 0, rmZFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int avoidHunt=rmCreateClassDistanceConstraint("Hunt vs Hunt", rmClassID("huntables"), 60.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 60.0);
   int avoidSheep=rmCreateTypeDistanceConstraint("avoid sheep", "sheep", 30.0);
   int avoidNugget=rmCreateClassDistanceConstraint("nugget avoids nugget", rmClassID("classNugget"), 60.0);
   int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("classNatives"), 10.0);
   int avoidNativesFar=rmCreateClassDistanceConstraint("avoid natives far", rmClassID("classNatives"), 90.0);
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 3.0);
   int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 15.0);
   int avoidExplorer=rmCreateClassDistanceConstraint("avoid Explorer", rmClassID("abstractExplorer"), 150.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // Cardinal Directions
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.65, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.35, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.4, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.6, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // PARENT AREA
   // NECCESSARY TO AVOID LAND BUILDING OVER WATER REINFORCEMENT POINTS
   int parentID=rmCreateArea("Parent");
   rmSetAreaSize(parentID, 0.75, 0.75);	
   rmSetAreaCoherence(parentID, 1.0);	
   rmSetAreaSmoothDistance(parentID, 15);
   rmSetAreaWaterType(parentID, "great lakes");
   rmSetAreaBaseHeight(parentID, 6.0);   
   rmSetAreaLocation(parentID, 0.35, 0.35);
   rmBuildArea(parentID);
   
   // MAIN CONTINENT 
   int ContinentID=rmCreateArea("center continent",parentID);
   rmSetAreaSize(ContinentID, 0.35, 0.35);	
   rmSetAreaCoherence(ContinentID, 0.1);	
   rmSetAreaSmoothDistance(ContinentID, 10);
   rmSetAreaMix(ContinentID, "carolina_grass");
   rmSetAreaBaseHeight(ContinentID, 2.0);   
   rmSetAreaLocation(ContinentID, 0.3, 0.3);
   rmBuildArea(ContinentID);

   // POINTS FOR WATERREINFORCMENTS 
   int waterFlagID=-1;
   for(i=1; <cNumberPlayers)
   {
     waterFlagID=rmCreateObjectDef("HC water flag "+i);
     rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
   }

   rmPlaceObjectDefAtLoc(waterFlagID, 1, 0.8, 0.75);
   rmPlaceObjectDefAtLoc(waterFlagID, 2, 0.75, 0.8);
   if(cNumberNonGaiaPlayers >= 3)
     rmPlaceObjectDefAtLoc(waterFlagID, 3, 0.85, 0.7);
   if(cNumberNonGaiaPlayers >= 4)
     rmPlaceObjectDefAtLoc(waterFlagID, 4, 0.7, 0.85);
   if(cNumberNonGaiaPlayers >= 5)
     rmPlaceObjectDefAtLoc(waterFlagID, 5, 0.9, 0.65);
   if(cNumberNonGaiaPlayers >= 6)
     rmPlaceObjectDefAtLoc(waterFlagID, 6, 0.65, 0.9);
   if(cNumberNonGaiaPlayers >= 7)
     rmPlaceObjectDefAtLoc(waterFlagID, 7, 0.95, 0.6);
   if(cNumberNonGaiaPlayers >= 8)
     rmPlaceObjectDefAtLoc(waterFlagID, 8, 0.6, 0.95);


   // STARTING 
   int startingExplorerID= rmCreateObjectDef("starting explorer");
   rmAddObjectDefItem(startingExplorerID, "Explorer", 1, 0.0);
   rmAddObjectDefToClass(startingExplorerID, rmClassID("classStartObject"));
   rmAddObjectDefToClass(startingExplorerID, rmClassID("abstractExplorer"));
   rmAddObjectDefConstraint(startingExplorerID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(startingExplorerID, edgeConstraint);
   rmAddObjectDefConstraint(startingExplorerID, avoidImpassableLand);
   rmAddObjectDefConstraint(startingExplorerID, avoidExplorer);

   int startingExplorerAztecID= rmCreateObjectDef("starting explorer Aztec");
   rmAddObjectDefItem(startingExplorerAztecID, "xpAztecWarchief", 1, 0.0);
   rmAddObjectDefToClass(startingExplorerAztecID, rmClassID("classStartObject"));
   rmAddObjectDefToClass(startingExplorerAztecID, rmClassID("abstractExplorer"));
   rmAddObjectDefConstraint(startingExplorerAztecID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(startingExplorerAztecID, edgeConstraint);
   rmAddObjectDefConstraint(startingExplorerAztecID, avoidImpassableLand);
   rmAddObjectDefConstraint(startingExplorerAztecID, avoidExplorer);

   int startingExplorerIroquoisID= rmCreateObjectDef("starting explorer Iroquois");
   rmAddObjectDefItem(startingExplorerIroquoisID, "xpIroquoisWarchief", 1, 0.0);
   rmAddObjectDefToClass(startingExplorerIroquoisID, rmClassID("classStartObject"));
   rmAddObjectDefToClass(startingExplorerIroquoisID, rmClassID("abstractExplorer"));
   rmAddObjectDefConstraint(startingExplorerIroquoisID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(startingExplorerIroquoisID, edgeConstraint);
   rmAddObjectDefConstraint(startingExplorerIroquoisID, avoidImpassableLand);
   rmAddObjectDefConstraint(startingExplorerIroquoisID, avoidExplorer);

   int startingExplorerSiouxID= rmCreateObjectDef("starting explorer Sioux");
   rmAddObjectDefItem(startingExplorerSiouxID, "xpLakotaWarchief", 1, 0.0);
   rmAddObjectDefToClass(startingExplorerSiouxID, rmClassID("classStartObject"));
   rmAddObjectDefToClass(startingExplorerSiouxID, rmClassID("abstractExplorer"));
   rmAddObjectDefConstraint(startingExplorerSiouxID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(startingExplorerSiouxID, edgeConstraint);
   rmAddObjectDefConstraint(startingExplorerSiouxID, avoidImpassableLand);
   rmAddObjectDefConstraint(startingExplorerSiouxID, avoidExplorer);
 
   int VilagerID= rmCreateObjectDef("Starting Villager");
   rmAddObjectDefItem(VilagerID, "Settler", 1, 0.0);
   rmAddObjectDefToClass(VilagerID, rmClassID("classStartObject"));
   rmAddObjectDefConstraint(VilagerID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(VilagerID, edgeConstraint);
   rmAddObjectDefConstraint(VilagerID, avoidImpassableLand);

   // FRENCH START WITH 4 COUREUR DE BOIS INSTEAD OF 5 STANDARD VILLAGERS
   int VilagerFrenchID= rmCreateObjectDef("Starting Villager French");
   rmAddObjectDefItem(VilagerFrenchID, "Coureur", 1, 0.0);
   rmAddObjectDefToClass(VilagerFrenchID, rmClassID("classStartObject"));
   rmAddObjectDefConstraint(VilagerFrenchID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(VilagerFrenchID, edgeConstraint);
   rmAddObjectDefConstraint(VilagerFrenchID, avoidImpassableLand);

   int startingOutpostID=rmCreateObjectDef("Starting Outpost");
   rmAddObjectDefItem(startingOutpostID, "Outpostwagon", 1, 0.0);
   rmAddObjectDefToClass(startingOutpostID, rmClassID("classStartObject"));
   rmAddObjectDefConstraint(startingOutpostID, avoidStartingUnitsFar);
   rmAddObjectDefConstraint(startingOutpostID, edgeConstraint);
   rmAddObjectDefConstraint(startingOutpostID, avoidImpassableLand);

   for(i=1; <cNumberPlayers)
   {	
     if(rmGetPlayerCiv(i) == rmGetCivID("xpAztec"))
       rmPlaceObjectDefInArea(startingExplorerAztecID, i, ContinentID, 1);
     else if (rmGetPlayerCiv(i) == rmGetCivID("xpIroquois"))
       rmPlaceObjectDefInArea(startingExplorerIroquoisID, i, ContinentID, 1);
     else if (rmGetPlayerCiv(i) == rmGetCivID("xpSioux"))
       rmPlaceObjectDefInArea(startingExplorerSiouxID, i, ContinentID, 1);
     else 
     {
       rmPlaceObjectDefInArea(startingExplorerID, i, ContinentID, 1);
       rmPlaceObjectDefInArea(startingOutpostID, i, ContinentID, 1);
     }
   }

   for(j=1; <cNumberPlayers)
   {
     if(rmGetPlayerCiv(j) == rmGetCivID("French"))
     {
       for(i=0; <4)
       {
         rmPlaceObjectDefInArea(VilagerFrenchID, j, ContinentID, 1);
       }
     }
     else
       for(i=0; <5)
       {
         rmPlaceObjectDefInArea(VilagerID, j, ContinentID, 1);
       }
   }


   if(cNumberNonGaiaPlayers == 2)
   {
     int IndianSetup = rmRandInt(1,2);
     int CaribVillageAID = -1;
     int CaribVillageTypeA = rmRandInt(1,3);
     if(whichTribe == 1) 
       CaribVillageAID = rmCreateGrouping("caribs city a", "native carib village 0"+CaribVillageTypeA); 
     else
       CaribVillageAID = rmCreateGrouping("caribs city a", "native Huron village "+CaribVillageTypeA); 
     rmAddGroupingToClass(CaribVillageAID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageAID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageAID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageAID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageAID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageAID, avoidAll);
     rmAddGroupingConstraint(CaribVillageAID, Westward);
     rmPlaceGroupingInArea(CaribVillageAID, 0, ContinentID, 1);

     int CaribVillageBID = -1;
     int CaribVillageTypeB = rmRandInt(1,3);
     if(whichTribe == 1)
       CaribVillageBID = rmCreateGrouping("caribs city b", "native carib village 0"+CaribVillageTypeB);
     else
       CaribVillageBID = rmCreateGrouping("caribs city b", "native Huron village "+CaribVillageTypeB);
     rmAddGroupingToClass(CaribVillageBID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageBID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageBID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageBID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageBID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageBID, avoidAll);
     rmAddGroupingConstraint(CaribVillageBID, Eastward);
     rmPlaceGroupingInArea(CaribVillageBID, 0, ContinentID, 1);
   }

   if(cNumberNonGaiaPlayers >= 3)
   {
     int CaribVillageCID = -1;
     int CaribVillageTypeC = rmRandInt(1,3);
     if(whichTribe == 1) 
       CaribVillageCID = rmCreateGrouping("caribs city c", "native carib village 0"+CaribVillageTypeC); 
     else
       CaribVillageCID = rmCreateGrouping("caribs city c", "native Huron village "+CaribVillageTypeC); 
     rmAddGroupingToClass(CaribVillageCID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageCID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageCID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageCID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageCID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageCID, avoidAll);
     rmAddGroupingConstraint(CaribVillageCID, Westward);
     rmPlaceGroupingInArea(CaribVillageCID, 0, ContinentID, 1);

     int CaribVillageDID = -1;
     int CaribVillageTypeD = rmRandInt(1,3);
     if(whichTribe == 1) 
       CaribVillageDID = rmCreateGrouping("caribs city d", "native carib village 0"+CaribVillageTypeD); 
     else
       CaribVillageDID = rmCreateGrouping("caribs city d", "native Huron village "+CaribVillageTypeD); 
     rmAddGroupingToClass(CaribVillageDID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageDID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageDID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageDID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageDID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageDID, avoidAll);
     rmAddGroupingConstraint(CaribVillageDID, Eastward);
     rmPlaceGroupingInArea(CaribVillageDID, 0, ContinentID, 1);

     int CaribVillageEID = -1;
     int CaribVillageTypeE = rmRandInt(1,3);
     if(whichTribe == 1) 
       CaribVillageEID = rmCreateGrouping("caribs city e", "native carib village 0"+CaribVillageTypeE); 
     else
       CaribVillageEID = rmCreateGrouping("caribs city e", "native Huron village "+CaribVillageTypeE); 
     rmAddGroupingToClass(CaribVillageEID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageEID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageEID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageEID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageEID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageEID, avoidAll);
     rmAddGroupingConstraint(CaribVillageEID, Westward);
     rmPlaceGroupingInArea(CaribVillageEID, 0, ContinentID, 1);

     int CaribVillageFID = -1;
     int CaribVillageTypeF = rmRandInt(1,3);
     if(whichTribe == 1) 
       CaribVillageFID = rmCreateGrouping("caribs city f", "native carib village 0"+CaribVillageTypeF); 
     else
       CaribVillageFID = rmCreateGrouping("caribs city f", "native Huron village "+CaribVillageTypeF); 
     rmAddGroupingToClass(CaribVillageFID, rmClassID("classNatives"));
     rmAddGroupingConstraint(CaribVillageFID, avoidNativesFar);
     rmAddGroupingConstraint(CaribVillageFID, avoidStartingUnitsMed);
     rmAddGroupingConstraint(CaribVillageFID, edgeConstraint);
     rmAddGroupingConstraint(CaribVillageFID, avoidImpassableLandFar);
     rmAddGroupingConstraint(CaribVillageFID, avoidAll);
     rmAddGroupingConstraint(CaribVillageFID, Eastward);
     rmPlaceGroupingInArea(CaribVillageFID, 0, ContinentID, 1);
   }

   // FOREST 
   int numForest = -1;
   int failCount = -1;
   numForest=22 + cNumberNonGaiaPlayers * 4;  
   failCount=0;

   for (i=0; <numForest)
   {   
      int Forest=rmCreateArea("Forest"+i,ContinentID);
      rmSetAreaSize(Forest, rmAreaTilesToFraction(220), rmAreaTilesToFraction(250));
      rmSetAreaForestType(Forest, "carolina pine forest");
      rmSetAreaForestDensity(Forest, 1.0);
      rmSetAreaForestClumpiness(Forest, 1.0);
      rmSetAreaForestUnderbrush(Forest, 0.0);
      rmSetAreaMinBlobs(Forest, 2);
      rmSetAreaMaxBlobs(Forest, 3);
      rmSetAreaMinBlobDistance(Forest, 4.0);
      rmSetAreaMaxBlobDistance(Forest, 8.0);
      rmSetAreaCoherence(Forest, 0.7);
      rmSetAreaSmoothDistance(Forest, 0);	
      rmAddAreaConstraint(Forest, forestConstraint); 
      rmAddAreaConstraint(Forest, avoidStartingUnits);	
      rmAddAreaConstraint(Forest, avoidNatives);	  
 
      if(rmBuildArea(Forest)==false)
      {  
         failCount++;
	 if(failCount==5)
	    break;
      }
      else
         failCount=0; 
   }

   int HuntID=rmCreateObjectDef("hunt");
   rmAddObjectDefItem(HuntID, "pronghorn", 5, 4.0);
   rmAddObjectDefToClass(HuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntID, avoidStartingUnits);
   rmAddObjectDefConstraint(HuntID, edgeConstraint);
   rmAddObjectDefConstraint(HuntID, avoidImpassableLand);
   rmAddObjectDefConstraint(HuntID, avoidHunt);
   rmAddObjectDefConstraint(HuntID, avoidNatives);
   rmAddObjectDefConstraint(HuntID, avoidAll);
   rmSetObjectDefCreateHerd(HuntID, true);
   rmPlaceObjectDefInArea(HuntID, 0, ContinentID, 6 + cNumberNonGaiaPlayers);

   int GoldID=rmCreateObjectDef("gold mine");
   rmAddObjectDefItem(GoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldID, avoidStartingUnits);
   rmAddObjectDefConstraint(GoldID, edgeConstraint);
   rmAddObjectDefConstraint(GoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(GoldID, avoidCoin);
   rmAddObjectDefConstraint(GoldID, avoidNatives);
   rmAddObjectDefConstraint(GoldID, avoidAll);
   rmPlaceObjectDefInArea(GoldID, 0, ContinentID, 6 + cNumberNonGaiaPlayers);

   int SheepID=rmCreateObjectDef("sheeps");
   rmAddObjectDefItem(SheepID, "sheep", 2, 3.0);
   rmAddObjectDefConstraint(SheepID, avoidStartingUnits);
   rmAddObjectDefConstraint(SheepID, avoidSheep);
   rmAddObjectDefConstraint(SheepID, avoidAll);
   rmPlaceObjectDefInArea(SheepID, 0, ContinentID, 6 + cNumberNonGaiaPlayers);

   int Sheep4ID=rmCreateObjectDef("four sheeps");
   rmAddObjectDefItem(Sheep4ID, "sheep", 4, 4.0);
   rmAddObjectDefConstraint(Sheep4ID, avoidStartingUnits);
   rmAddObjectDefConstraint(Sheep4ID, avoidSheep);
   rmAddObjectDefConstraint(Sheep4ID, avoidAll);
   rmPlaceObjectDefInArea(Sheep4ID, 0, ContinentID, 6 + cNumberNonGaiaPlayers);

   int NuggetID=rmCreateObjectDef("treasures");
   rmAddObjectDefItem(NuggetID, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(NuggetID, rmClassID("classNugget"));
   rmAddObjectDefConstraint(NuggetID, avoidStartingUnits);
   rmAddObjectDefConstraint(NuggetID, edgeConstraint);
   rmAddObjectDefConstraint(NuggetID, avoidImpassableLand);
   rmAddObjectDefConstraint(NuggetID, avoidNugget);
   rmAddObjectDefConstraint(NuggetID, avoidNatives);
   rmAddObjectDefConstraint(NuggetID, avoidAll);
   rmPlaceObjectDefInArea(NuggetID, 0, ContinentID, 3 + cNumberNonGaiaPlayers / 2);

   int NuggetSmallID=rmCreateObjectDef("treasures small");
   rmAddObjectDefItem(NuggetSmallID, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(1, 1);
   rmAddObjectDefToClass(NuggetSmallID, rmClassID("classNugget"));
   rmAddObjectDefConstraint(NuggetSmallID, avoidStartingUnits);
   rmAddObjectDefConstraint(NuggetSmallID, edgeConstraint);
   rmAddObjectDefConstraint(NuggetSmallID, avoidImpassableLand);
   rmAddObjectDefConstraint(NuggetSmallID, avoidNugget);
   rmAddObjectDefConstraint(NuggetSmallID, avoidNatives);
   rmAddObjectDefConstraint(NuggetSmallID, avoidAll);
   if(cNumberNonGaiaPlayers <= 4)
     rmPlaceObjectDefInArea(NuggetSmallID, 0, ContinentID, 2);
   else 
     rmPlaceObjectDefInArea(NuggetSmallID, 0, ContinentID, 3);

   // FISH 
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 40.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishCod", 3, 6.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmAddObjectDefConstraint(fishID, avoidAll);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12 + cNumberNonGaiaPlayers);

   // WHALES 
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 70.0);
   int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 12.0);
   int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "minkeWhale", 1, 6.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmAddObjectDefConstraint(whaleID, avoidAll);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3 + cNumberNonGaiaPlayers / 2);

   // STRAGGLERS
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, "TreeGreatLakes", rmRandInt(1,3), 4.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmSetObjectDefMinDistance(StragglerTreeID, 0.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   rmPlaceObjectDefInArea(StragglerTreeID, 0, ContinentID, 16 + cNumberNonGaiaPlayers * 2);


   // SURPRESS BONUS VILS AND CRATES FOR BUILDING TC WITH TRIGGER
   rmCreateTrigger("NoCratesTrigger");
   rmSwitchToTrigger(rmTriggerID("NoCratesTrigger"));
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     rmAddTriggerEffect("Player : Toggle TC Spawning");
     rmSetTriggerEffectParamInt("Player",i);
     rmSetTriggerEffectParam("AllowSpawning","false");
     rmSetTriggerPriority(4);
     rmSetTriggerActive(true);
     rmSetTriggerRunImmediately(true);
     rmSetTriggerLoop(false);
   }

   // GIVE 200 WOOD AT START 
   rmCreateTrigger("StartWithWood");
   rmSwitchToTrigger(rmTriggerID("StartWithWood"));
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     rmAddTriggerEffect("Grant Resources");
     rmSetTriggerEffectParamInt("PlayerID",i);
     rmSetTriggerEffectParam("ResName","Wood");
     rmSetTriggerEffectParamInt("Amount",200);
     rmSetTriggerPriority(4);
     rmSetTriggerActive(true);
     rmSetTriggerRunImmediately(true);
     rmSetTriggerLoop(false);
   }

   // SOLVING THE OTTOMAN VIL SPAWNING PROBLEM WITH A WORKAROUND

   // DEFINING TRIGGERS FOR LATER USE
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmCreateTrigger("AllowDelayedSpawn"+i);
       rmCreateTrigger("ZeroTC"+i);
       rmCreateTrigger("OneTC"+i);
       rmCreateTrigger("TwoTC"+i);
       rmCreateTrigger("ThreeTC"+i);
     }
   }

   // ONE SEC DELAY FOR REACTIVATION OF SETTLER SPAWNING 
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmSwitchToTrigger(rmTriggerID("AllowDelayedSpawn"+i));
       rmAddTriggerCondition("Timer");
       rmSetTriggerConditionParamInt("Param1", 1);
       rmAddTriggerEffect("Player : Toggle TC Spawning");
       rmSetTriggerEffectParamInt("Player",i);
       rmSetTriggerEffectParam("AllowSpawning","true");
       rmSetTriggerPriority(4);
       rmSetTriggerActive(true);
       rmSetTriggerRunImmediately(true);
       rmSetTriggerLoop(false);
     }
   }

   // IF THERE IS ZERO TC FOR THAT PLAYER, STARTING POINT - YOU CAN CONSIDER THIS AS AN AUTOMAT
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmSwitchToTrigger(rmTriggerID("ZeroTc"+i));
       rmAddTriggerCondition("Player Unit Count");
       rmSetTriggerConditionParamInt("PlayerID", i);
       rmSetTriggerConditionParam("ProtoUnit","Towncenter");
       rmSetTriggerConditionParam("Op","==");
       rmSetTriggerConditionParamInt("Count", 0);
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("OneTC"+i));
       rmSetTriggerPriority(4);
       rmSetTriggerActive(true);
       rmSetTriggerRunImmediately(true);
       rmSetTriggerLoop(false);
     }
   }

   // IF THERE IS ONE TC FOR THAT PLAYER 
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmSwitchToTrigger(rmTriggerID("OneTc"+i));
       rmAddTriggerCondition("Player Unit Count");
       rmSetTriggerConditionParamInt("PlayerID", i);
       rmSetTriggerConditionParam("ProtoUnit","Towncenter");
       rmSetTriggerConditionParam("Op","==");
       rmSetTriggerConditionParamInt("Count", 1);
       rmAddTriggerEffect("Player : Toggle TC Spawning");
       rmSetTriggerEffectParamInt("Player",i);
       rmSetTriggerEffectParam("AllowSpawning","false");
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("AllowDelayedSpawn"+i));
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("ZeroTC"+i));
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("TwoTC"+i));
       rmSetTriggerPriority(4);
       rmSetTriggerActive(true);
       rmSetTriggerRunImmediately(true);
       rmSetTriggerLoop(false);
     }
   }

   // IF THERE IS TWO TC FOR THAT PLAYER 
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmSwitchToTrigger(rmTriggerID("TwoTc"+i));
       rmAddTriggerCondition("Player Unit Count");
       rmSetTriggerConditionParamInt("PlayerID", i);
       rmSetTriggerConditionParam("ProtoUnit","Towncenter");
       rmSetTriggerConditionParam("Op","==");
       rmSetTriggerConditionParamInt("Count", 2);
       rmAddTriggerEffect("Player : Toggle TC Spawning");
       rmSetTriggerEffectParamInt("Player",i);
       rmSetTriggerEffectParam("AllowSpawning","false");
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("AllowDelayedSpawn"+i));
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("OneTC"+i));
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("ThreeTC"+i));
       rmSetTriggerPriority(4);
       rmSetTriggerActive(true);
       rmSetTriggerRunImmediately(true);
       rmSetTriggerLoop(false);
     }
   }

   // IF THERE IS THREE TC FOR THAT PLAYER 
   for(i=1; <= cNumberNonGaiaPlayers)
   {
     if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
     {
       rmSwitchToTrigger(rmTriggerID("ThreeTc"+i));
       rmAddTriggerCondition("Player Unit Count");
       rmSetTriggerConditionParamInt("PlayerID", i);
       rmSetTriggerConditionParam("ProtoUnit","Towncenter");
       rmSetTriggerConditionParam("Op","==");
       rmSetTriggerConditionParamInt("Count", 3);
       rmAddTriggerEffect("Player : Toggle TC Spawning");
       rmSetTriggerEffectParamInt("Player",i);
       rmSetTriggerEffectParam("AllowSpawning","false");
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("AllowDelayedSpawn"+i));
       rmAddTriggerEffect("Fire Event");
       rmSetTriggerEffectParamInt("EventID",rmTriggerID("TwoTC"+i));
       rmSetTriggerPriority(4);
       rmSetTriggerActive(true);
       rmSetTriggerRunImmediately(true);
       rmSetTriggerLoop(false);
     }
   }
}  