
// WINDY ISLES TWC
// OKTOBER 2006 BY MARTIN 'ORCA' SCHMIDT

void main(void)
{
   // MAPSIZE 
   int playerTiles=14000;
   if (cNumberNonGaiaPlayers == 2)
     playerTiles = 15000;
   if (cNumberNonGaiaPlayers == 4)
     playerTiles = 14000;
   if (cNumberNonGaiaPlayers == 6)
     playerTiles = 13000;
   if (cNumberNonGaiaPlayers == 8)
     playerTiles = 12500;

   int size=2.0*sqrt(cNumberNonGaiaPlayers * playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1);
	
   // TERRAIN 
   rmSetSeaLevel(0.0);
   rmSetLightingSet("patagonia");
   rmSetSeaType("great lakes");
   rmTerrainInitialize("water");
   rmSetWindMagnitude(3.0);

   // THIS LINES MUST BE HERE FOR TREASURES
   rmSetMapType("patagonia");
   rmSetMapType("water");
   rmSetMapType("grass");

   // CLASSES 
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classNatives");
   rmDefineClass("huntables");
   rmDefineClass("classCliff");
   rmDefineClass("classNuggets");

   // CHOOSING THE TRIBES
   int tribes = rmRandInt(1,3);
   if(tribes == 1)
   {
     rmSetSubCiv(0, "Tupi");
     rmSetSubCiv(1, "Incas");
   }
   if(tribes == 2)
   {
     rmSetSubCiv(0, "Tupi");
     rmSetSubCiv(1, "Mapuche");
   }
   if(tribes == 3)
   {
     rmSetSubCiv(0, "Incas");
     rmSetSubCiv(1, "Tupi");
   }
   if(tribes == 4)
   {
     rmSetSubCiv(0, "Incas");
     rmSetSubCiv(1, "Mapuche");
   }
   if(tribes == 5)
   {
     rmSetSubCiv(0, "Mapuche");
     rmSetSubCiv(1, "Tupi");
   }
   if(tribes == 6)
   {
     rmSetSubCiv(0, "Mapuche");
     rmSetSubCiv(1, "Incas");
   }

   // CONSTRAINTS 
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAllFar=rmCreateTypeDistanceConstraint("avoid all Far", "all", 10.0);
   int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("classNatives"), 10.0);
   int avoidNativesFar=rmCreateClassDistanceConstraint("avoid natives far", rmClassID("classNatives"), 70.0);
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 15.0);
   int circleIndianConstraint=rmCreatePieConstraint("circle Indian Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.42), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidHunt=rmCreateClassDistanceConstraint("Hunt vs Hunt", rmClassID("huntables"), 45.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 45.0);
   int avoidHerd=rmCreateTypeDistanceConstraint("avoid llama", "llama", 50.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 40.0);
   int avoidNuggets=rmCreateClassDistanceConstraint("nuggets avoids nuggets", rmClassID("classNuggets"), 70.0);
   int edgeConstraint=rmCreatePieConstraint("things avoid edge", 0.5, 0.5, 0, rmZFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
   int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
   int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 20.0);

   // Cardinal Directions
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.4, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.6, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
   int ForestEastward=rmCreatePieConstraint("foresteastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int ForestWestward=rmCreatePieConstraint("forestwestMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // PLAYER PLACEMENT 
   if(cNumberNonGaiaPlayers == 2)
   {
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.48,0.54);			
     rmPlacePlayersCircular(0.3, 0.35, 0);

     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.76,0.82);		
     rmPlacePlayersCircular(0.3, 0.35, 0);
   }

   if(cNumberNonGaiaPlayers == 4)
   {
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.4,0.54);			
     rmPlacePlayersCircular(0.32, 0.36, 0);
	
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.71,0.85);		
     rmPlacePlayersCircular(0.32, 0.36, 0);
   }

   if(cNumberNonGaiaPlayers == 6)
   {
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.37,0.55);			
     rmPlacePlayersCircular(0.35, 0.4, 0);
	
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.69,0.87);		
     rmPlacePlayersCircular(0.35, 0.4, 0);
   }

   if(cNumberNonGaiaPlayers == 8)
   {
     rmSetPlacementTeam(0);		
     rmSetPlacementSection(0.35,0.57);			
     rmPlacePlayersCircular(0.35, 0.4, 0);
	
     rmSetPlacementTeam(1);				
     rmSetPlacementSection(0.68,0.9);		
     rmPlacePlayersCircular(0.35, 0.4, 0);
   }

   if((cNumberNonGaiaPlayers == 3) || (cNumberNonGaiaPlayers == 5) || (cNumberNonGaiaPlayers == 7))
   {
     if(cNumberNonGaiaPlayers == 7)
     {
       rmSetPlacementTeam(-1);
       rmSetPlacementSection(0.35,0.90);		
       rmPlacePlayersCircular(0.35, 0.4, 0);
     }
     else
     {
       rmSetPlacementTeam(-1);
       rmSetPlacementSection(0.4,0.85);		
       rmPlacePlayersCircular(0.32, 0.36, 0);
     }
   }

   // PLAYER AREAS
   float playerFraction=rmAreaTilesToFraction(1250);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaCoherence(id, 0.6);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaBaseHeight(id, 2.0);
      rmAddAreaConstraint(id, edgeConstraint);
      rmSetAreaMix(id, "pampas_grass");
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();
   
   // MAIN LAND , KEEP AWAY FROM PLAYER ISLANDS 
   int ContinentXID=rmCreateArea("mainland");
   for(i=1; <cNumberPlayers)
     rmAddAreaConstraint(ContinentXID,rmCreateAreaDistanceConstraint("No connection"+i,rmAreaID("Player"+i),25.0));
   rmSetAreaSize(ContinentXID, 0.3, 0.3);
   rmAddAreaInfluenceSegment(ContinentXID, 1.0, 0.6, 0.6, 1.0);	
   rmSetAreaCoherence(ContinentXID, 0.3);	
   rmSetAreaSmoothDistance(ContinentXID, 10);
   rmSetAreaMix(ContinentXID, "patagonia_grass");
   rmSetAreaBaseHeight(ContinentXID, 6.0);   
   rmSetAreaLocation(ContinentXID, 0.6, 0.6);
   rmBuildArea(ContinentXID);
 
   // STARTING UNITS 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);

   // STARTING PLACE 
   int startingTCID= rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
     rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   else
     rmAddObjectDefItem(startingTCID, "townCenter", 1, 0.0);
	
   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // POINTS FOR WATERREINFORCMENTS 
   int waterFlagID=-1;
   int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
   int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
   int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
   for(i=1; <cNumberPlayers)
   {
     waterFlagID=rmCreateObjectDef("HC water flag "+i);
     rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
     rmAddClosestPointConstraint(flagEdgeConstraint);
     rmAddClosestPointConstraint(flagVsFlag);
     rmAddClosestPointConstraint(flagLand);
     vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
     vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

     rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
     rmClearClosestPointConstraints();
   }

   // TRADE ROUTES 
   int tradeRouteID = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID, 1.0, 0.6);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 1.0);
   rmBuildTradeRoute(tradeRouteID, "dirt");

   // TRADE POINTS
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 8.0);
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.1);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.9);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // INDIANS 
   int IndianVillageAID = -1;
   int IndianVillageTypeA = rmRandInt(1,3);
   if(tribes == 1)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Tupi village "+IndianVillageTypeA);
   if(tribes == 2)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Tupi village "+IndianVillageTypeA);
   if(tribes == 3)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Inca village "+IndianVillageTypeA);
   if(tribes == 4)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Inca village "+IndianVillageTypeA);
   if(tribes == 5)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Mapuche village "+IndianVillageTypeA);
   if(tribes == 6)
     IndianVillageAID = rmCreateGrouping("caribs city a", "native Mapuche village "+IndianVillageTypeA);
   rmAddGroupingToClass(IndianVillageAID, rmClassID("classNatives"));
   rmAddGroupingConstraint(IndianVillageAID, avoidTradeRouteFar);
   rmAddGroupingConstraint(IndianVillageAID, avoidNativesFar);
   rmAddGroupingConstraint(IndianVillageAID, avoidImpassableLandFar);
   rmAddGroupingConstraint(IndianVillageAID, circleIndianConstraint);
   rmAddGroupingConstraint(IndianVillageAID, Eastward);
   rmPlaceGroupingInArea(IndianVillageAID, 0, ContinentXID);

   int IndianVillageBID = -1;
   int IndianVillageTypeB = rmRandInt(1,3);
   if(tribes == 1)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Tupi village "+IndianVillageTypeB);
   if(tribes == 2)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Tupi village "+IndianVillageTypeB);
   if(tribes == 3)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Inca village "+IndianVillageTypeB);
   if(tribes == 4)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Inca village "+IndianVillageTypeB);
   if(tribes == 5)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Mapuche village "+IndianVillageTypeB);
   if(tribes == 6)
     IndianVillageBID = rmCreateGrouping("caribs city b", "native Mapuche village "+IndianVillageTypeB);
   rmAddGroupingToClass(IndianVillageBID, rmClassID("classNatives"));
   rmAddGroupingConstraint(IndianVillageBID, avoidTradeRouteFar);
   rmAddGroupingConstraint(IndianVillageBID, avoidNativesFar);
   rmAddGroupingConstraint(IndianVillageBID, avoidImpassableLandFar);
   rmAddGroupingConstraint(IndianVillageBID, circleIndianConstraint);
   rmAddGroupingConstraint(IndianVillageBID, Westward);
   rmPlaceGroupingInArea(IndianVillageBID, 0, ContinentXID);

   if(cNumberNonGaiaPlayers > 3)
   {
     int IndianVillageCID = -1;
     int IndianVillageTypeC = rmRandInt(1,3);
     if(tribes == 1)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Inca village "+IndianVillageTypeC);
     if(tribes == 2)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Mapuche village "+IndianVillageTypeC);
     if(tribes == 3)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Tupi village "+IndianVillageTypeC);
     if(tribes == 1)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Mapuche village "+IndianVillageTypeC);
     if(tribes == 2)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Tupi village "+IndianVillageTypeC);
     if(tribes == 3)
       IndianVillageCID = rmCreateGrouping("caribs city c", "native Inca village "+IndianVillageTypeC);
     rmAddGroupingToClass(IndianVillageCID, rmClassID("classNatives"));
     rmAddGroupingConstraint(IndianVillageCID, avoidTradeRouteFar);
     rmAddGroupingConstraint(IndianVillageCID, avoidNativesFar);
     rmAddGroupingConstraint(IndianVillageCID, avoidImpassableLandFar);
     rmAddGroupingConstraint(IndianVillageCID, circleIndianConstraint);
     rmAddGroupingConstraint(IndianVillageCID, Eastward);
     rmPlaceGroupingInArea(IndianVillageCID, 0, ContinentXID);

     int IndianVillageDID = -1;
     int IndianVillageTypeD = rmRandInt(1,3);
     if(tribes == 1)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Inca village "+IndianVillageTypeD);
     if(tribes == 2)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Mapuche village "+IndianVillageTypeD);
     if(tribes == 3)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Tupi village "+IndianVillageTypeD);
     if(tribes == 4)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Mapuche village "+IndianVillageTypeD);
     if(tribes == 5)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Tupi village "+IndianVillageTypeD);
     if(tribes == 6)
       IndianVillageDID = rmCreateGrouping("caribs city d", "native Inca village "+IndianVillageTypeD);
     rmAddGroupingToClass(IndianVillageDID, rmClassID("classNatives"));
     rmAddGroupingConstraint(IndianVillageDID, avoidTradeRouteFar);
     rmAddGroupingConstraint(IndianVillageDID, avoidNativesFar);
     rmAddGroupingConstraint(IndianVillageDID, avoidImpassableLandFar);
     rmAddGroupingConstraint(IndianVillageDID, circleIndianConstraint);
     rmAddGroupingConstraint(IndianVillageDID, Westward);
     rmPlaceGroupingInArea(IndianVillageDID, 0, ContinentXID);
   }

   // FOREST
   int numForestAWest = -1;
   int failCountAWest = -1;
   numForestAWest=3 + cNumberNonGaiaPlayers * 2;  
   failCountAWest=0;

   for (i=0; <numForestAWest)
   {   
      int ForestAWest=rmCreateArea("Forest"+i,rmAreaID("mainland"));
      rmSetAreaSize(ForestAWest, rmAreaTilesToFraction(170), rmAreaTilesToFraction(200));
      rmSetAreaForestType(ForestAWest, "patagonia forest");

      rmSetAreaForestDensity(ForestAWest, 1.0);
      rmSetAreaForestClumpiness(ForestAWest, 0.0);
      rmSetAreaCoherence(ForestAWest, 1.0);
      rmSetAreaSmoothDistance(ForestAWest, 0);
      rmSetAreaForestUnderbrush(ForestAWest, 0.0);
      rmSetAreaMinBlobs(ForestAWest, 1);
      rmSetAreaMaxBlobs(ForestAWest, 1);
      rmSetAreaMinBlobDistance(ForestAWest, 5.0);
      rmSetAreaMaxBlobDistance(ForestAWest, 5.0);
		   
      rmAddAreaConstraint(ForestAWest, ForestWestward);
      rmAddAreaConstraint(ForestAWest, avoidTradeRoute);										
      rmAddAreaConstraint(ForestAWest, avoidNatives);
      if(rmBuildArea(ForestAWest)==false)
      {  
         failCountAWest++;
	 if(failCountAWest==5)
	    break;
      }
      else
         failCountAWest=0; 
   }

   int numForestBEast = -1;
   int failCountBEast = -1;
   numForestBEast=3 + cNumberNonGaiaPlayers * 2;  
   failCountBEast=0;

   for (i=0; <numForestBEast)
   {   
      int ForestBEast=rmCreateArea("Forest"+i+100,rmAreaID("mainland"));
      rmSetAreaSize(ForestBEast, rmAreaTilesToFraction(170), rmAreaTilesToFraction(200));
      rmSetAreaForestType(ForestBEast, "patagonia forest");

      rmSetAreaForestDensity(ForestBEast, 1.0);
      rmSetAreaForestClumpiness(ForestBEast, 0.0);
      rmSetAreaCoherence(ForestBEast, 1.0);
      rmSetAreaSmoothDistance(ForestBEast, 0);
      rmSetAreaForestUnderbrush(ForestBEast, 0.0);
      rmSetAreaMinBlobs(ForestBEast, 1);
      rmSetAreaMaxBlobs(ForestBEast, 1);
      rmSetAreaMinBlobDistance(ForestBEast, 5.0);
      rmSetAreaMaxBlobDistance(ForestBEast, 5.0);
	
      rmAddAreaConstraint(ForestBEast, ForestEastward);	   
      rmAddAreaConstraint(ForestBEast, avoidTradeRoute);										
      rmAddAreaConstraint(ForestBEast, avoidNatives);
      if(rmBuildArea(ForestBEast)==false)
      {  
         failCountBEast++;
	 if(failCountBEast==5)
	    break;
      }
      else
         failCountBEast=0; 
   }


   // PLAYER FOREST 
   int failCountPlayer = -1;
   int ForestPlayer = -1;

   for (i=1; <cNumberPlayers)
   {   
      ForestPlayer=rmCreateArea("Forest"+i+200,rmAreaID("Player"+i));
      rmSetAreaSize(ForestPlayer, rmAreaTilesToFraction(70), rmAreaTilesToFraction(90));
      rmSetAreaForestType(ForestPlayer, "pampas forest");

      rmSetAreaForestDensity(ForestPlayer, 1.0);
      rmSetAreaForestClumpiness(ForestPlayer, 0.0);
      rmSetAreaCoherence(ForestPlayer, 1.0);
      rmSetAreaSmoothDistance(ForestPlayer, 0);
      rmSetAreaForestUnderbrush(ForestPlayer, 0.0);
      rmSetAreaMinBlobs(ForestPlayer, 1);
      rmSetAreaMaxBlobs(ForestPlayer, 1);
      rmSetAreaMinBlobDistance(ForestPlayer, 5.0);
      rmSetAreaMaxBlobDistance(ForestPlayer, 5.0);	
      rmAddAreaConstraint(ForestPlayer, avoidAllFar);	   

      if(rmBuildArea(ForestPlayer)==false)
      {  
         failCountPlayer++;
	 if(failCountPlayer==5)
	    break;
      }
      else
         failCountPlayer=0; 
   }


   // CLIFFS
   int numTries=4;
   int failCount=0;
   for(i=0; <4)
   {
     int cliffEastID=rmCreateArea("cliff east"+i,rmAreaID("mainland"));
     rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(200));  	
     rmSetAreaCliffType(cliffEastID, "Patagonia");
     rmAddAreaToClass(cliffEastID, rmClassID("classCliff"));
     rmSetAreaCliffEdge(cliffEastID, 2, 0.4, 0.1, 1.0, 0);
     rmSetAreaCliffPainting(cliffEastID, true, true, true, 1.5, true);
     rmSetAreaCliffHeight(cliffEastID, 3, 1.0, 1.0);
     rmSetAreaHeightBlend(cliffEastID, 1);
     rmAddAreaConstraint(cliffEastID, avoidCliffs);				
     rmAddAreaConstraint(cliffEastID, avoidTradeRoute);
     rmAddAreaConstraint(cliffEastID, avoidCoin);
     rmAddAreaConstraint(cliffEastID, avoidNatives);
     rmSetAreaMinBlobs(cliffEastID, 1);
     rmSetAreaMaxBlobs(cliffEastID, 1);
     rmSetAreaMinBlobDistance(cliffEastID, 10.0);
     rmSetAreaMaxBlobDistance(cliffEastID, 10.0);
     rmSetAreaCoherence(cliffEastID, 0.2);
     rmSetAreaSmoothDistance(cliffEastID, 10);						

     if(rmBuildArea(cliffEastID)==false)
     {
       // Stop trying once we fail 3 times in a row
       failCount++;
       if(failCount==3)
         break;
     }
     else
       failCount=0;
   }

   // RESOURCES PER PLAYER 
   if (rmGetNomadStart() == false)
   {
     int playerCrateID=rmCreateObjectDef("bonus starting crates");
     rmAddObjectDefItem(playerCrateID, "crateOfWood", 2.0, 2.0);
     rmSetObjectDefMinDistance(playerCrateID, 6);
     rmSetObjectDefMaxDistance(playerCrateID, 10);
     rmAddObjectDefConstraint(playerCrateID, avoidAll);
     rmAddObjectDefConstraint(playerCrateID, avoidImpassableLand);
     rmAddObjectDefConstraint(playerCrateID, avoidStartResource);
     rmPlaceObjectDefPerPlayer(playerCrateID, false,1);
   }

   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false,2);

   int StartHuntID=rmCreateObjectDef("starting hunt");
   rmAddObjectDefItem(StartHuntID, "rhea", 5, 6.0);
   rmSetObjectDefMinDistance(StartHuntID, 25);
   rmSetObjectDefMaxDistance(StartHuntID, 30);
   rmAddObjectDefConstraint(StartHuntID, avoidStartResource);
   rmAddObjectDefConstraint(StartHuntID, avoidAll);
   rmSetObjectDefCreateHerd(StartHuntID, true);
   rmPlaceObjectDefPerPlayer(StartHuntID, false,1);

   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmSetObjectDefMinDistance(playerGoldID, 20.0);
   rmSetObjectDefMaxDistance(playerGoldID, 25.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false,1);

   int playerBerryID=rmCreateObjectDef("player berry");
   rmAddObjectDefItem(playerBerryID, "berryBush", 5.0, 3.0);
   rmAddObjectDefConstraint(playerBerryID, avoidImpassableLand);
   rmAddObjectDefConstraint(playerBerryID, avoidAll);
   rmSetObjectDefMinDistance(playerBerryID, 15.0);
   rmSetObjectDefMaxDistance(playerBerryID, 20.0);
   rmPlaceObjectDefPerPlayer(playerBerryID, false,1);

   int playerHerdID=rmCreateObjectDef("player herd");
   rmAddObjectDefItem(playerHerdID, "llama", 2, 3.0);
   rmAddObjectDefConstraint(playerHerdID, avoidAll);
   rmSetObjectDefMinDistance(playerHerdID, 25.0);
   rmSetObjectDefMaxDistance(playerHerdID, 30.0);
   rmPlaceObjectDefPerPlayer(playerHerdID, false,1);

   // RESOURCES FOR MAINLAND
   int HuntID=rmCreateObjectDef("hunt");
   rmAddObjectDefItem(HuntID, "rhea", 7, 6.0);
   rmAddObjectDefToClass(HuntID, rmClassID("huntables"));
   rmAddObjectDefConstraint(HuntID, edgeConstraint);
   rmAddObjectDefConstraint(HuntID, avoidImpassableLand);
   rmAddObjectDefConstraint(HuntID, avoidTradeRoute);
   rmAddObjectDefConstraint(HuntID, avoidHunt);
   rmAddObjectDefConstraint(HuntID, avoidNatives);
   rmAddObjectDefConstraint(HuntID, avoidAll);
   rmSetObjectDefCreateHerd(HuntID, true);
   rmPlaceObjectDefInArea(HuntID, 0, ContinentXID, 6 + cNumberNonGaiaPlayers);

   int GoldID=rmCreateObjectDef("gold mine");
   rmAddObjectDefItem(GoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldID, edgeConstraint);
   rmAddObjectDefConstraint(GoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(GoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldID, avoidCoin);
   rmAddObjectDefConstraint(GoldID, avoidNatives);
   rmAddObjectDefConstraint(GoldID, avoidAll);
   rmPlaceObjectDefInArea(GoldID, 0, ContinentXID, 6 + cNumberNonGaiaPlayers);

   int HerdID=rmCreateObjectDef("herd");
   rmAddObjectDefItem(HerdID, "llama", 2, 3.0);
   rmAddObjectDefConstraint(HerdID, avoidHerd);
   rmAddObjectDefConstraint(HerdID, avoidAll);
   rmPlaceObjectDefInArea(HerdID, 0, ContinentXID, 4 + cNumberNonGaiaPlayers/2);

   // Treasures
   int nugget1= rmCreateObjectDef("nugget easy"); 
   rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefConstraint(nugget1, avoidAll);
   rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
   rmAddObjectDefToClass(nugget1, rmClassID("classNuggets"));
   rmSetObjectDefMinDistance(nugget1, 20.0);
   rmSetObjectDefMaxDistance(nugget1, 30.0);
   rmPlaceObjectDefPerPlayer(nugget1, false, 1);

   int nuggetIndi=rmCreateObjectDef("free nugget");
   rmAddObjectDefItem(nuggetIndi,  "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefConstraint(nuggetIndi, avoidTradeRoute);
   rmAddObjectDefConstraint(nuggetIndi, avoidAll);
   rmAddObjectDefConstraint(nuggetIndi, avoidNuggets);
   rmAddObjectDefConstraint(nuggetIndi, edgeConstraint);
   rmAddObjectDefConstraint(nuggetIndi, avoidImpassableLand);
   rmAddObjectDefToClass(nuggetIndi, rmClassID("classNuggets"));
   rmPlaceObjectDefInArea(nuggetIndi, 0, ContinentXID, cNumberNonGaiaPlayers/2);

   int nuggetBIndi=rmCreateObjectDef("free nugget b");
   rmAddObjectDefItem(nuggetBIndi,  "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefConstraint(nuggetBIndi, avoidTradeRoute);
   rmAddObjectDefConstraint(nuggetBIndi, avoidAll);
   rmAddObjectDefConstraint(nuggetBIndi, avoidNuggets);
   rmAddObjectDefConstraint(nuggetBIndi, edgeConstraint);
   rmAddObjectDefConstraint(nuggetBIndi, avoidImpassableLand);
   rmAddObjectDefToClass(nuggetBIndi, rmClassID("classNuggets"));
   rmPlaceObjectDefInArea(nuggetBIndi, 0, ContinentXID, 2 + cNumberNonGaiaPlayers/2);

   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, "TreePatagoniaDirt", 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmPlaceObjectDefInArea(StragglerTreeID, 0, ContinentXID, 20 + cNumberNonGaiaPlayers * 2);

   // FISH 
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 30.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishCod", 2, 5.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 22 + cNumberNonGaiaPlayers * 4);

   // WHALES 
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 50.0);
   int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 12.0);
   int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "minkeWhale", 1, 6.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 6 + cNumberNonGaiaPlayers * 2);   
}